!! LANL:license
! -------------------------------------------------------------------------
! This SOFTWARE has been authored by an employee or employees of the
! University of California, operator of the Los Alamos National Laboratory
! under Contract No. W-7405-ENG-36 with the U.S. Department of Energy.
! The U.S. Government has rights to use, reproduce, and distribute this
! SOFTWARE.  The public may copy, distribute, prepare derivative works and
! publicly display this SOFTWARE without charge, provided that this Notice
! and any statement of authorship are reproduced on all copies.  Neither
! the Government nor the University makes any warranty, express or implied,
! or assumes any liability or responsibility for the use of this SOFTWARE.
! If SOFTWARE is modified to produce derivative works, such modified
! SOFTWARE should be clearly marked, so as not to confuse it with the
! version available from LANL.
! -------------------------------------------------------------------------
! LANL:license
! -------------------------------------------------------------------------
!
! ARMCI_Malloc_F.f90 - this file is automatically created
!
! The Fortran procedures in this file allocate and free ARMCI based arrays.
!
! -------------------------------------------------------------------------


module ARMCI
  use F90_kinds

  interface ARMCI_Malloc
    module procedure ARMCI_Malloc_1DI1
    module procedure ARMCI_Malloc_1DI2
    module procedure ARMCI_Malloc_1DI
    module procedure ARMCI_Malloc_1DI8
    module procedure ARMCI_Malloc_1DR
    module procedure ARMCI_Malloc_1DD
    module procedure ARMCI_Malloc_1DC
    module procedure ARMCI_Malloc_1DDC
    module procedure ARMCI_Malloc_2DI1
    module procedure ARMCI_Malloc_2DI2
    module procedure ARMCI_Malloc_2DI
    module procedure ARMCI_Malloc_2DI8
    module procedure ARMCI_Malloc_2DR
    module procedure ARMCI_Malloc_2DD
    module procedure ARMCI_Malloc_2DC
    module procedure ARMCI_Malloc_2DDC
    module procedure ARMCI_Malloc_3DI1
    module procedure ARMCI_Malloc_3DI2
    module procedure ARMCI_Malloc_3DI
    module procedure ARMCI_Malloc_3DI8
    module procedure ARMCI_Malloc_3DR
    module procedure ARMCI_Malloc_3DD
    module procedure ARMCI_Malloc_3DC
    module procedure ARMCI_Malloc_3DDC
    module procedure ARMCI_Malloc_4DI1
    module procedure ARMCI_Malloc_4DI2
    module procedure ARMCI_Malloc_4DI
    module procedure ARMCI_Malloc_4DI8
    module procedure ARMCI_Malloc_4DR
    module procedure ARMCI_Malloc_4DD
    module procedure ARMCI_Malloc_4DC
    module procedure ARMCI_Malloc_4DDC
    module procedure ARMCI_Malloc_5DI1
    module procedure ARMCI_Malloc_5DI2
    module procedure ARMCI_Malloc_5DI
    module procedure ARMCI_Malloc_5DI8
    module procedure ARMCI_Malloc_5DR
    module procedure ARMCI_Malloc_5DD
    module procedure ARMCI_Malloc_5DC
    module procedure ARMCI_Malloc_5DDC
    module procedure ARMCI_Malloc_6DI1
    module procedure ARMCI_Malloc_6DI2
    module procedure ARMCI_Malloc_6DI
    module procedure ARMCI_Malloc_6DI8
    module procedure ARMCI_Malloc_6DR
    module procedure ARMCI_Malloc_6DD
    module procedure ARMCI_Malloc_6DC
    module procedure ARMCI_Malloc_6DDC
    module procedure ARMCI_Malloc_7DI1
    module procedure ARMCI_Malloc_7DI2
    module procedure ARMCI_Malloc_7DI
    module procedure ARMCI_Malloc_7DI8
    module procedure ARMCI_Malloc_7DR
    module procedure ARMCI_Malloc_7DD
    module procedure ARMCI_Malloc_7DC
    module procedure ARMCI_Malloc_7DDC
  end interface

  interface ARMCI_Free
    module procedure ARMCI_Free_1DI1
    module procedure ARMCI_Free_1DI2
    module procedure ARMCI_Free_1DI
    module procedure ARMCI_Free_1DI8
    module procedure ARMCI_Free_1DR
    module procedure ARMCI_Free_1DD
    module procedure ARMCI_Free_1DC
    module procedure ARMCI_Free_1DDC
    module procedure ARMCI_Free_2DI1
    module procedure ARMCI_Free_2DI2
    module procedure ARMCI_Free_2DI
    module procedure ARMCI_Free_2DI8
    module procedure ARMCI_Free_2DR
    module procedure ARMCI_Free_2DD
    module procedure ARMCI_Free_2DC
    module procedure ARMCI_Free_2DDC
    module procedure ARMCI_Free_3DI1
    module procedure ARMCI_Free_3DI2
    module procedure ARMCI_Free_3DI
    module procedure ARMCI_Free_3DI8
    module procedure ARMCI_Free_3DR
    module procedure ARMCI_Free_3DD
    module procedure ARMCI_Free_3DC
    module procedure ARMCI_Free_3DDC
    module procedure ARMCI_Free_4DI1
    module procedure ARMCI_Free_4DI2
    module procedure ARMCI_Free_4DI
    module procedure ARMCI_Free_4DI8
    module procedure ARMCI_Free_4DR
    module procedure ARMCI_Free_4DD
    module procedure ARMCI_Free_4DC
    module procedure ARMCI_Free_4DDC
    module procedure ARMCI_Free_5DI1
    module procedure ARMCI_Free_5DI2
    module procedure ARMCI_Free_5DI
    module procedure ARMCI_Free_5DI8
    module procedure ARMCI_Free_5DR
    module procedure ARMCI_Free_5DD
    module procedure ARMCI_Free_5DC
    module procedure ARMCI_Free_5DDC
    module procedure ARMCI_Free_6DI1
    module procedure ARMCI_Free_6DI2
    module procedure ARMCI_Free_6DI
    module procedure ARMCI_Free_6DI8
    module procedure ARMCI_Free_6DR
    module procedure ARMCI_Free_6DD
    module procedure ARMCI_Free_6DC
    module procedure ARMCI_Free_6DDC
    module procedure ARMCI_Free_7DI1
    module procedure ARMCI_Free_7DI2
    module procedure ARMCI_Free_7DI
    module procedure ARMCI_Free_7DI8
    module procedure ARMCI_Free_7DR
    module procedure ARMCI_Free_7DD
    module procedure ARMCI_Free_7DC
    module procedure ARMCI_Free_7DDC
  end interface

contains

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DI1(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I1(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_I1(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DI1: error = ", rc

end subroutine ARMCI_Malloc_1DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DI1(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I1(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_I1(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DI1: error = ", rc

end subroutine ARMCI_Free_1DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DI2(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I2(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_I2(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DI2: error = ", rc

end subroutine ARMCI_Malloc_1DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DI2(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I2(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_I2(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DI2: error = ", rc

end subroutine ARMCI_Free_1DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DI(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I(a, rank, lb, ub, rc)
      use F90_kinds
      integer, pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I
  end interface
  integer, pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_I(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DI: error = ", rc

end subroutine ARMCI_Malloc_1DI

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DI(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I(a, rank, rc)
      use F90_kinds
      integer, pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I
  end interface
  integer, pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_I(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DI: error = ", rc

end subroutine ARMCI_Free_1DI

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DI8(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I8(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_I8(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DI8: error = ", rc

end subroutine ARMCI_Malloc_1DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DI8(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I8(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_I8(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DI8: error = ", rc

end subroutine ARMCI_Free_1DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DR(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_R(a, rank, lb, ub, rc)
      use F90_kinds
      real, pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_R
  end interface
  real, pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_R(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DR: error = ", rc

end subroutine ARMCI_Malloc_1DR

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DR(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_R(a, rank, rc)
      use F90_kinds
      real, pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_R
  end interface
  real, pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_R(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DR: error = ", rc

end subroutine ARMCI_Free_1DR

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DD(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_D(a, rank, lb, ub, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_D
  end interface
  real(kind(1.0D0)), pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_D(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DD: error = ", rc

end subroutine ARMCI_Malloc_1DD

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DD(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_D(a, rank, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_D
  end interface
  real(kind(1.0D0)), pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_D(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DD: error = ", rc

end subroutine ARMCI_Free_1DD

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_C(a, rank, lb, ub, rc)
      use F90_kinds
      complex, pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_C
  end interface
  complex, pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_C(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DC: error = ", rc

end subroutine ARMCI_Malloc_1DC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_C(a, rank, rc)
      use F90_kinds
      complex, pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_C
  end interface
  complex, pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_C(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DC: error = ", rc

end subroutine ARMCI_Free_1DC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_1DDC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_DC(a, rank, lb, ub, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:)
      integer, intent(in)  :: rank, lb(1), ub(1)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:)
  integer, intent(in) :: lb(1), ub(1)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Malloc_DC(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_1DDC: error = ", rc

end subroutine ARMCI_Malloc_1DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_1DDC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_DC(a, rank, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:)
  integer, intent(out), optional :: rc
  integer :: rank = 1

  call ARMCI_Free_DC(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_1DDC: error = ", rc

end subroutine ARMCI_Free_1DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DI1(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I1(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_I1(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DI1: error = ", rc

end subroutine ARMCI_Malloc_2DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DI1(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I1(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_I1(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DI1: error = ", rc

end subroutine ARMCI_Free_2DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DI2(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I2(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_I2(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DI2: error = ", rc

end subroutine ARMCI_Malloc_2DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DI2(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I2(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_I2(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DI2: error = ", rc

end subroutine ARMCI_Free_2DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DI(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I(a, rank, lb, ub, rc)
      use F90_kinds
      integer, pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I
  end interface
  integer, pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_I(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DI: error = ", rc

end subroutine ARMCI_Malloc_2DI

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DI(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I(a, rank, rc)
      use F90_kinds
      integer, pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I
  end interface
  integer, pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_I(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DI: error = ", rc

end subroutine ARMCI_Free_2DI

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DI8(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I8(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_I8(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DI8: error = ", rc

end subroutine ARMCI_Malloc_2DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DI8(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I8(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_I8(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DI8: error = ", rc

end subroutine ARMCI_Free_2DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DR(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_R(a, rank, lb, ub, rc)
      use F90_kinds
      real, pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_R
  end interface
  real, pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_R(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DR: error = ", rc

end subroutine ARMCI_Malloc_2DR

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DR(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_R(a, rank, rc)
      use F90_kinds
      real, pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_R
  end interface
  real, pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_R(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DR: error = ", rc

end subroutine ARMCI_Free_2DR

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DD(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_D(a, rank, lb, ub, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_D(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DD: error = ", rc

end subroutine ARMCI_Malloc_2DD

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DD(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_D(a, rank, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_D(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DD: error = ", rc

end subroutine ARMCI_Free_2DD

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_C(a, rank, lb, ub, rc)
      use F90_kinds
      complex, pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_C
  end interface
  complex, pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_C(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DC: error = ", rc

end subroutine ARMCI_Malloc_2DC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_C(a, rank, rc)
      use F90_kinds
      complex, pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_C
  end interface
  complex, pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_C(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DC: error = ", rc

end subroutine ARMCI_Free_2DC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_2DDC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_DC(a, rank, lb, ub, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:)
      integer, intent(in)  :: rank, lb(2), ub(2)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:)
  integer, intent(in) :: lb(2), ub(2)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Malloc_DC(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_2DDC: error = ", rc

end subroutine ARMCI_Malloc_2DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_2DDC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_DC(a, rank, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 2

  call ARMCI_Free_DC(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_2DDC: error = ", rc

end subroutine ARMCI_Free_2DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DI1(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I1(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_I1(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DI1: error = ", rc

end subroutine ARMCI_Malloc_3DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DI1(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I1(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_I1(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DI1: error = ", rc

end subroutine ARMCI_Free_3DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DI2(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I2(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_I2(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DI2: error = ", rc

end subroutine ARMCI_Malloc_3DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DI2(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I2(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_I2(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DI2: error = ", rc

end subroutine ARMCI_Free_3DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DI(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I(a, rank, lb, ub, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I
  end interface
  integer, pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_I(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DI: error = ", rc

end subroutine ARMCI_Malloc_3DI

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DI(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I(a, rank, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I
  end interface
  integer, pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_I(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DI: error = ", rc

end subroutine ARMCI_Free_3DI

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DI8(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I8(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_I8(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DI8: error = ", rc

end subroutine ARMCI_Malloc_3DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DI8(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I8(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_I8(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DI8: error = ", rc

end subroutine ARMCI_Free_3DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DR(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_R(a, rank, lb, ub, rc)
      use F90_kinds
      real, pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_R
  end interface
  real, pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_R(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DR: error = ", rc

end subroutine ARMCI_Malloc_3DR

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DR(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_R(a, rank, rc)
      use F90_kinds
      real, pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_R
  end interface
  real, pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_R(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DR: error = ", rc

end subroutine ARMCI_Free_3DR

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DD(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_D(a, rank, lb, ub, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_D(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DD: error = ", rc

end subroutine ARMCI_Malloc_3DD

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DD(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_D(a, rank, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_D(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DD: error = ", rc

end subroutine ARMCI_Free_3DD

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_C(a, rank, lb, ub, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_C
  end interface
  complex, pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_C(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DC: error = ", rc

end subroutine ARMCI_Malloc_3DC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_C(a, rank, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_C
  end interface
  complex, pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_C(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DC: error = ", rc

end subroutine ARMCI_Free_3DC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_3DDC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_DC(a, rank, lb, ub, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:)
      integer, intent(in)  :: rank, lb(3), ub(3)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:)
  integer, intent(in) :: lb(3), ub(3)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Malloc_DC(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_3DDC: error = ", rc

end subroutine ARMCI_Malloc_3DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_3DDC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_DC(a, rank, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 3

  call ARMCI_Free_DC(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_3DDC: error = ", rc

end subroutine ARMCI_Free_3DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DI1(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I1(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_I1(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DI1: error = ", rc

end subroutine ARMCI_Malloc_4DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DI1(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I1(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_I1(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DI1: error = ", rc

end subroutine ARMCI_Free_4DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DI2(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I2(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_I2(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DI2: error = ", rc

end subroutine ARMCI_Malloc_4DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DI2(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I2(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_I2(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DI2: error = ", rc

end subroutine ARMCI_Free_4DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DI(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I(a, rank, lb, ub, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I
  end interface
  integer, pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_I(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DI: error = ", rc

end subroutine ARMCI_Malloc_4DI

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DI(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I(a, rank, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I
  end interface
  integer, pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_I(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DI: error = ", rc

end subroutine ARMCI_Free_4DI

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DI8(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I8(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_I8(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DI8: error = ", rc

end subroutine ARMCI_Malloc_4DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DI8(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I8(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_I8(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DI8: error = ", rc

end subroutine ARMCI_Free_4DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DR(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_R(a, rank, lb, ub, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_R
  end interface
  real, pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_R(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DR: error = ", rc

end subroutine ARMCI_Malloc_4DR

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DR(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_R(a, rank, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_R
  end interface
  real, pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_R(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DR: error = ", rc

end subroutine ARMCI_Free_4DR

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DD(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_D(a, rank, lb, ub, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_D(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DD: error = ", rc

end subroutine ARMCI_Malloc_4DD

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DD(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_D(a, rank, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_D(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DD: error = ", rc

end subroutine ARMCI_Free_4DD

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_C(a, rank, lb, ub, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_C
  end interface
  complex, pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_C(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DC: error = ", rc

end subroutine ARMCI_Malloc_4DC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_C(a, rank, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_C
  end interface
  complex, pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_C(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DC: error = ", rc

end subroutine ARMCI_Free_4DC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_4DDC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_DC(a, rank, lb, ub, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank, lb(4), ub(4)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:)
  integer, intent(in) :: lb(4), ub(4)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Malloc_DC(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_4DDC: error = ", rc

end subroutine ARMCI_Malloc_4DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_4DDC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_DC(a, rank, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 4

  call ARMCI_Free_DC(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_4DDC: error = ", rc

end subroutine ARMCI_Free_4DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DI1(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I1(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_I1(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DI1: error = ", rc

end subroutine ARMCI_Malloc_5DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DI1(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I1(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_I1(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DI1: error = ", rc

end subroutine ARMCI_Free_5DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DI2(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I2(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_I2(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DI2: error = ", rc

end subroutine ARMCI_Malloc_5DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DI2(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I2(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_I2(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DI2: error = ", rc

end subroutine ARMCI_Free_5DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DI(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I(a, rank, lb, ub, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I
  end interface
  integer, pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_I(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DI: error = ", rc

end subroutine ARMCI_Malloc_5DI

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DI(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I(a, rank, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I
  end interface
  integer, pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_I(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DI: error = ", rc

end subroutine ARMCI_Free_5DI

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DI8(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I8(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_I8(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DI8: error = ", rc

end subroutine ARMCI_Malloc_5DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DI8(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I8(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_I8(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DI8: error = ", rc

end subroutine ARMCI_Free_5DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DR(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_R(a, rank, lb, ub, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_R
  end interface
  real, pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_R(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DR: error = ", rc

end subroutine ARMCI_Malloc_5DR

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DR(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_R(a, rank, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_R
  end interface
  real, pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_R(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DR: error = ", rc

end subroutine ARMCI_Free_5DR

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DD(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_D(a, rank, lb, ub, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_D(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DD: error = ", rc

end subroutine ARMCI_Malloc_5DD

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DD(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_D(a, rank, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_D(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DD: error = ", rc

end subroutine ARMCI_Free_5DD

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_C(a, rank, lb, ub, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_C
  end interface
  complex, pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_C(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DC: error = ", rc

end subroutine ARMCI_Malloc_5DC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_C(a, rank, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_C
  end interface
  complex, pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_C(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DC: error = ", rc

end subroutine ARMCI_Free_5DC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_5DDC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_DC(a, rank, lb, ub, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank, lb(5), ub(5)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:)
  integer, intent(in) :: lb(5), ub(5)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Malloc_DC(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_5DDC: error = ", rc

end subroutine ARMCI_Malloc_5DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_5DDC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_DC(a, rank, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 5

  call ARMCI_Free_DC(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_5DDC: error = ", rc

end subroutine ARMCI_Free_5DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DI1(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I1(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_I1(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DI1: error = ", rc

end subroutine ARMCI_Malloc_6DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DI1(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I1(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_I1(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DI1: error = ", rc

end subroutine ARMCI_Free_6DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DI2(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I2(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_I2(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DI2: error = ", rc

end subroutine ARMCI_Malloc_6DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DI2(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I2(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_I2(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DI2: error = ", rc

end subroutine ARMCI_Free_6DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DI(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I(a, rank, lb, ub, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I
  end interface
  integer, pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_I(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DI: error = ", rc

end subroutine ARMCI_Malloc_6DI

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DI(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I(a, rank, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I
  end interface
  integer, pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_I(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DI: error = ", rc

end subroutine ARMCI_Free_6DI

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DI8(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I8(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_I8(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DI8: error = ", rc

end subroutine ARMCI_Malloc_6DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DI8(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I8(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_I8(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DI8: error = ", rc

end subroutine ARMCI_Free_6DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DR(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_R(a, rank, lb, ub, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_R
  end interface
  real, pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_R(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DR: error = ", rc

end subroutine ARMCI_Malloc_6DR

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DR(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_R(a, rank, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_R
  end interface
  real, pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_R(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DR: error = ", rc

end subroutine ARMCI_Free_6DR

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DD(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_D(a, rank, lb, ub, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_D(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DD: error = ", rc

end subroutine ARMCI_Malloc_6DD

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DD(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_D(a, rank, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_D(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DD: error = ", rc

end subroutine ARMCI_Free_6DD

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_C(a, rank, lb, ub, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_C
  end interface
  complex, pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_C(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DC: error = ", rc

end subroutine ARMCI_Malloc_6DC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_C(a, rank, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_C
  end interface
  complex, pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_C(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DC: error = ", rc

end subroutine ARMCI_Free_6DC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_6DDC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_DC(a, rank, lb, ub, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(6), ub(6)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
  integer, intent(in) :: lb(6), ub(6)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Malloc_DC(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_6DDC: error = ", rc

end subroutine ARMCI_Malloc_6DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_6DDC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_DC(a, rank, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 6

  call ARMCI_Free_DC(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_6DDC: error = ", rc

end subroutine ARMCI_Free_6DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DI1(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I1(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_I1(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DI1: error = ", rc

end subroutine ARMCI_Malloc_7DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DI1(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I1(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I1
  end interface
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_I1(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DI1: error = ", rc

end subroutine ARMCI_Free_7DI1

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DI2(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I2(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_I2(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DI2: error = ", rc

end subroutine ARMCI_Malloc_7DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DI2(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I2(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I2
  end interface
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_I2(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DI2: error = ", rc

end subroutine ARMCI_Free_7DI2

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DI(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I(a, rank, lb, ub, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I
  end interface
  integer, pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_I(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DI: error = ", rc

end subroutine ARMCI_Malloc_7DI

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DI(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I(a, rank, rc)
      use F90_kinds
      integer, pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I
  end interface
  integer, pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_I(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DI: error = ", rc

end subroutine ARMCI_Free_7DI

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DI8(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_I8(a, rank, lb, ub, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_I8(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DI8: error = ", rc

end subroutine ARMCI_Malloc_7DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DI8(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_I8(a, rank, rc)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_I8
  end interface
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_I8(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DI8: error = ", rc

end subroutine ARMCI_Free_7DI8

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DR(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_R(a, rank, lb, ub, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_R
  end interface
  real, pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_R(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DR: error = ", rc

end subroutine ARMCI_Malloc_7DR

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DR(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_R(a, rank, rc)
      use F90_kinds
      real, pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_R
  end interface
  real, pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_R(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DR: error = ", rc

end subroutine ARMCI_Free_7DR

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DD(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_D(a, rank, lb, ub, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_D(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DD: error = ", rc

end subroutine ARMCI_Malloc_7DD

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DD(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_D(a, rank, rc)
      use F90_kinds
      real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_D
  end interface
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_D(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DD: error = ", rc

end subroutine ARMCI_Free_7DD

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_C(a, rank, lb, ub, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_C
  end interface
  complex, pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_C(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DC: error = ", rc

end subroutine ARMCI_Malloc_7DC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_C(a, rank, rc)
      use F90_kinds
      complex, pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_C
  end interface
  complex, pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_C(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DC: error = ", rc

end subroutine ARMCI_Free_7DC

!--------------------------------------------------------------------------
subroutine ARMCI_Malloc_7DDC(a, lb, ub, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Malloc_DC(a, rank, lb, ub, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank, lb(7), ub(7)
      integer, intent(out) :: rc
    end subroutine ARMCI_Malloc_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(in) :: lb(7), ub(7)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Malloc_DC(a, rank, lb, ub, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Malloc_7DDC: error = ", rc

end subroutine ARMCI_Malloc_7DDC

!--------------------------------------------------------------------------
subroutine ARMCI_Free_7DDC(a, rc)
  use F90_kinds
  implicit none
  interface
    subroutine ARMCI_Free_DC(a, rank, rc)
      use F90_kinds
      complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
      integer, intent(in)  :: rank
      integer, intent(out) :: rc
    end subroutine ARMCI_Free_DC
  end interface
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
  integer, intent(out), optional :: rc
  integer :: rank = 7

  call ARMCI_Free_DC(a, rank, rc)
  if (rc .ne. 0) print *, "ERROR ARMCI_Free_7DDC: error = ", rc

end subroutine ARMCI_Free_7DDC


end module ARMCI


