!! LANL:license
! -------------------------------------------------------------------------
! This SOFTWARE has been authored by an employee or employees of the
! University of California, operator of the Los Alamos National Laboratory
! under Contract No. W-7405-ENG-36 with the U.S. Department of Energy.
! The U.S. Government has rights to use, reproduce, and distribute this
! SOFTWARE.  The public may copy, distribute, prepare derivative works and
! publicly display this SOFTWARE without charge, provided that this Notice
! and any statement of authorship are reproduced on all copies.  Neither
! the Government nor the University makes any warranty, express or implied,
! or assumes any liability or responsibility for the use of this SOFTWARE.
! If SOFTWARE is modified to produce derivative works, such modified
! SOFTWARE should be clearly marked, so as not to confuse it with the
! version available from LANL.
! -------------------------------------------------------------------------
! LANL:license
! -------------------------------------------------------------------------
!
! F90CreateArray.f90 - this file is automatically created
!
! The Fortran procedures in this file create and destroy pointers to
! arrays.  Standard usage is to call these procedures from C++.  The
! large number of procedures are needed, since Fortran is now
! strongly typed and there is no casting mechanism.
!
! -------------------------------------------------------------------------


module F90_ArrayTypes
  use F90_kinds

  type F90_Array1DI1_t
    integer(kind=IKIND1), pointer :: data(:)
  end type F90_Array1DI1_t

  type F90_Array1DI2_t
    integer(kind=IKIND2), pointer :: data(:)
  end type F90_Array1DI2_t

  type F90_Array1DI_t
    integer, pointer :: data(:)
  end type F90_Array1DI_t

  type F90_Array1DI4_t
    integer(kind=IKIND4), pointer :: data(:)
  end type F90_Array1DI4_t

  type F90_Array1DI8_t
    integer(kind=IKIND8), pointer :: data(:)
  end type F90_Array1DI8_t

  type F90_Array1DL1_t
    logical(kind=IKIND1), pointer :: data(:)
  end type F90_Array1DL1_t

  type F90_Array1DL2_t
    logical(kind=IKIND2), pointer :: data(:)
  end type F90_Array1DL2_t

  type F90_Array1DL_t
    logical, pointer :: data(:)
  end type F90_Array1DL_t

  type F90_Array1DL4_t
    logical(kind=IKIND4), pointer :: data(:)
  end type F90_Array1DL4_t

  type F90_Array1DL8_t
    logical(kind=IKIND8), pointer :: data(:)
  end type F90_Array1DL8_t

  type F90_Array1DR_t
    real, pointer :: data(:)
  end type F90_Array1DR_t

  type F90_Array1DD_t
    real(kind(1.0D0)), pointer :: data(:)
  end type F90_Array1DD_t

  type F90_Array1DC_t
    complex, pointer :: data(:)
  end type F90_Array1DC_t

  type F90_Array1DDC_t
    complex(kind(1.0D0)), pointer :: data(:)
  end type F90_Array1DDC_t

  type F90_Array2DI1_t
    integer(kind=IKIND1), pointer :: data(:,:)
  end type F90_Array2DI1_t

  type F90_Array2DI2_t
    integer(kind=IKIND2), pointer :: data(:,:)
  end type F90_Array2DI2_t

  type F90_Array2DI_t
    integer, pointer :: data(:,:)
  end type F90_Array2DI_t

  type F90_Array2DI4_t
    integer(kind=IKIND4), pointer :: data(:,:)
  end type F90_Array2DI4_t

  type F90_Array2DI8_t
    integer(kind=IKIND8), pointer :: data(:,:)
  end type F90_Array2DI8_t

  type F90_Array2DL1_t
    logical(kind=IKIND1), pointer :: data(:,:)
  end type F90_Array2DL1_t

  type F90_Array2DL2_t
    logical(kind=IKIND2), pointer :: data(:,:)
  end type F90_Array2DL2_t

  type F90_Array2DL_t
    logical, pointer :: data(:,:)
  end type F90_Array2DL_t

  type F90_Array2DL4_t
    logical(kind=IKIND4), pointer :: data(:,:)
  end type F90_Array2DL4_t

  type F90_Array2DL8_t
    logical(kind=IKIND8), pointer :: data(:,:)
  end type F90_Array2DL8_t

  type F90_Array2DR_t
    real, pointer :: data(:,:)
  end type F90_Array2DR_t

  type F90_Array2DD_t
    real(kind(1.0D0)), pointer :: data(:,:)
  end type F90_Array2DD_t

  type F90_Array2DC_t
    complex, pointer :: data(:,:)
  end type F90_Array2DC_t

  type F90_Array2DDC_t
    complex(kind(1.0D0)), pointer :: data(:,:)
  end type F90_Array2DDC_t

  type F90_Array3DI1_t
    integer(kind=IKIND1), pointer :: data(:,:,:)
  end type F90_Array3DI1_t

  type F90_Array3DI2_t
    integer(kind=IKIND2), pointer :: data(:,:,:)
  end type F90_Array3DI2_t

  type F90_Array3DI_t
    integer, pointer :: data(:,:,:)
  end type F90_Array3DI_t

  type F90_Array3DI4_t
    integer(kind=IKIND4), pointer :: data(:,:,:)
  end type F90_Array3DI4_t

  type F90_Array3DI8_t
    integer(kind=IKIND8), pointer :: data(:,:,:)
  end type F90_Array3DI8_t

  type F90_Array3DL1_t
    logical(kind=IKIND1), pointer :: data(:,:,:)
  end type F90_Array3DL1_t

  type F90_Array3DL2_t
    logical(kind=IKIND2), pointer :: data(:,:,:)
  end type F90_Array3DL2_t

  type F90_Array3DL_t
    logical, pointer :: data(:,:,:)
  end type F90_Array3DL_t

  type F90_Array3DL4_t
    logical(kind=IKIND4), pointer :: data(:,:,:)
  end type F90_Array3DL4_t

  type F90_Array3DL8_t
    logical(kind=IKIND8), pointer :: data(:,:,:)
  end type F90_Array3DL8_t

  type F90_Array3DR_t
    real, pointer :: data(:,:,:)
  end type F90_Array3DR_t

  type F90_Array3DD_t
    real(kind(1.0D0)), pointer :: data(:,:,:)
  end type F90_Array3DD_t

  type F90_Array3DC_t
    complex, pointer :: data(:,:,:)
  end type F90_Array3DC_t

  type F90_Array3DDC_t
    complex(kind(1.0D0)), pointer :: data(:,:,:)
  end type F90_Array3DDC_t

  type F90_Array4DI1_t
    integer(kind=IKIND1), pointer :: data(:,:,:,:)
  end type F90_Array4DI1_t

  type F90_Array4DI2_t
    integer(kind=IKIND2), pointer :: data(:,:,:,:)
  end type F90_Array4DI2_t

  type F90_Array4DI_t
    integer, pointer :: data(:,:,:,:)
  end type F90_Array4DI_t

  type F90_Array4DI4_t
    integer(kind=IKIND4), pointer :: data(:,:,:,:)
  end type F90_Array4DI4_t

  type F90_Array4DI8_t
    integer(kind=IKIND8), pointer :: data(:,:,:,:)
  end type F90_Array4DI8_t

  type F90_Array4DL1_t
    logical(kind=IKIND1), pointer :: data(:,:,:,:)
  end type F90_Array4DL1_t

  type F90_Array4DL2_t
    logical(kind=IKIND2), pointer :: data(:,:,:,:)
  end type F90_Array4DL2_t

  type F90_Array4DL_t
    logical, pointer :: data(:,:,:,:)
  end type F90_Array4DL_t

  type F90_Array4DL4_t
    logical(kind=IKIND4), pointer :: data(:,:,:,:)
  end type F90_Array4DL4_t

  type F90_Array4DL8_t
    logical(kind=IKIND8), pointer :: data(:,:,:,:)
  end type F90_Array4DL8_t

  type F90_Array4DR_t
    real, pointer :: data(:,:,:,:)
  end type F90_Array4DR_t

  type F90_Array4DD_t
    real(kind(1.0D0)), pointer :: data(:,:,:,:)
  end type F90_Array4DD_t

  type F90_Array4DC_t
    complex, pointer :: data(:,:,:,:)
  end type F90_Array4DC_t

  type F90_Array4DDC_t
    complex(kind(1.0D0)), pointer :: data(:,:,:,:)
  end type F90_Array4DDC_t

  type F90_Array5DI1_t
    integer(kind=IKIND1), pointer :: data(:,:,:,:,:)
  end type F90_Array5DI1_t

  type F90_Array5DI2_t
    integer(kind=IKIND2), pointer :: data(:,:,:,:,:)
  end type F90_Array5DI2_t

  type F90_Array5DI_t
    integer, pointer :: data(:,:,:,:,:)
  end type F90_Array5DI_t

  type F90_Array5DI4_t
    integer(kind=IKIND4), pointer :: data(:,:,:,:,:)
  end type F90_Array5DI4_t

  type F90_Array5DI8_t
    integer(kind=IKIND8), pointer :: data(:,:,:,:,:)
  end type F90_Array5DI8_t

  type F90_Array5DL1_t
    logical(kind=IKIND1), pointer :: data(:,:,:,:,:)
  end type F90_Array5DL1_t

  type F90_Array5DL2_t
    logical(kind=IKIND2), pointer :: data(:,:,:,:,:)
  end type F90_Array5DL2_t

  type F90_Array5DL_t
    logical, pointer :: data(:,:,:,:,:)
  end type F90_Array5DL_t

  type F90_Array5DL4_t
    logical(kind=IKIND4), pointer :: data(:,:,:,:,:)
  end type F90_Array5DL4_t

  type F90_Array5DL8_t
    logical(kind=IKIND8), pointer :: data(:,:,:,:,:)
  end type F90_Array5DL8_t

  type F90_Array5DR_t
    real, pointer :: data(:,:,:,:,:)
  end type F90_Array5DR_t

  type F90_Array5DD_t
    real(kind(1.0D0)), pointer :: data(:,:,:,:,:)
  end type F90_Array5DD_t

  type F90_Array5DC_t
    complex, pointer :: data(:,:,:,:,:)
  end type F90_Array5DC_t

  type F90_Array5DDC_t
    complex(kind(1.0D0)), pointer :: data(:,:,:,:,:)
  end type F90_Array5DDC_t

  type F90_Array6DI1_t
    integer(kind=IKIND1), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DI1_t

  type F90_Array6DI2_t
    integer(kind=IKIND2), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DI2_t

  type F90_Array6DI_t
    integer, pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DI_t

  type F90_Array6DI4_t
    integer(kind=IKIND4), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DI4_t

  type F90_Array6DI8_t
    integer(kind=IKIND8), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DI8_t

  type F90_Array6DL1_t
    logical(kind=IKIND1), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DL1_t

  type F90_Array6DL2_t
    logical(kind=IKIND2), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DL2_t

  type F90_Array6DL_t
    logical, pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DL_t

  type F90_Array6DL4_t
    logical(kind=IKIND4), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DL4_t

  type F90_Array6DL8_t
    logical(kind=IKIND8), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DL8_t

  type F90_Array6DR_t
    real, pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DR_t

  type F90_Array6DD_t
    real(kind(1.0D0)), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DD_t

  type F90_Array6DC_t
    complex, pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DC_t

  type F90_Array6DDC_t
    complex(kind(1.0D0)), pointer :: data(:,:,:,:,:,:)
  end type F90_Array6DDC_t

  type F90_Array7DI1_t
    integer(kind=IKIND1), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DI1_t

  type F90_Array7DI2_t
    integer(kind=IKIND2), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DI2_t

  type F90_Array7DI_t
    integer, pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DI_t

  type F90_Array7DI4_t
    integer(kind=IKIND4), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DI4_t

  type F90_Array7DI8_t
    integer(kind=IKIND8), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DI8_t

  type F90_Array7DL1_t
    logical(kind=IKIND1), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DL1_t

  type F90_Array7DL2_t
    logical(kind=IKIND2), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DL2_t

  type F90_Array7DL_t
    logical, pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DL_t

  type F90_Array7DL4_t
    logical(kind=IKIND4), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DL4_t

  type F90_Array7DL8_t
    logical(kind=IKIND8), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DL8_t

  type F90_Array7DR_t
    real, pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DR_t

  type F90_Array7DD_t
    real(kind(1.0D0)), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DD_t

  type F90_Array7DC_t
    complex, pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DC_t

  type F90_Array7DDC_t
    complex(kind(1.0D0)), pointer :: data(:,:,:,:,:,:,:)
  end type F90_Array7DDC_t

end module F90_ArrayTypes


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DI1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DI1(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DI1_t), intent(out) :: dest
      type(F90_Array1DI1_t), intent(in) :: src
    end subroutine F90_CopyDesc1DI1
  end interface
  type(F90_Array1DI1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  integer(kind=IKIND1), pointer :: a(:)
  type(F90_Array1DI1_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DI1(ptr, a_t)
end subroutine F90_CreateArray1DI1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DI1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DI1(a_t)
      use F90_ArrayTypes
      type(F90_Array1DI1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DI1
  end interface
  type(F90_Array1DI1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DI1(a_t)
end subroutine F90_DestroyArray1DI1


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DI2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DI2(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DI2_t), intent(out) :: dest
      type(F90_Array1DI2_t), intent(in) :: src
    end subroutine F90_CopyDesc1DI2
  end interface
  type(F90_Array1DI2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  integer(kind=IKIND2), pointer :: a(:)
  type(F90_Array1DI2_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DI2(ptr, a_t)
end subroutine F90_CreateArray1DI2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DI2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DI2(a_t)
      use F90_ArrayTypes
      type(F90_Array1DI2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DI2
  end interface
  type(F90_Array1DI2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DI2(a_t)
end subroutine F90_DestroyArray1DI2


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DI(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DI(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DI_t), intent(out) :: dest
      type(F90_Array1DI_t), intent(in) :: src
    end subroutine F90_CopyDesc1DI
  end interface
  type(F90_Array1DI_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  integer, pointer :: a(:)
  type(F90_Array1DI_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DI(ptr, a_t)
end subroutine F90_CreateArray1DI

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DI(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DI(a_t)
      use F90_ArrayTypes
      type(F90_Array1DI_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DI
  end interface
  type(F90_Array1DI_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DI(a_t)
end subroutine F90_DestroyArray1DI


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DI4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DI4(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DI4_t), intent(out) :: dest
      type(F90_Array1DI4_t), intent(in) :: src
    end subroutine F90_CopyDesc1DI4
  end interface
  type(F90_Array1DI4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  integer(kind=IKIND4), pointer :: a(:)
  type(F90_Array1DI4_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DI4(ptr, a_t)
end subroutine F90_CreateArray1DI4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DI4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DI4(a_t)
      use F90_ArrayTypes
      type(F90_Array1DI4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DI4
  end interface
  type(F90_Array1DI4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DI4(a_t)
end subroutine F90_DestroyArray1DI4


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DI8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DI8(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DI8_t), intent(out) :: dest
      type(F90_Array1DI8_t), intent(in) :: src
    end subroutine F90_CopyDesc1DI8
  end interface
  type(F90_Array1DI8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  integer(kind=IKIND8), pointer :: a(:)
  type(F90_Array1DI8_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DI8(ptr, a_t)
end subroutine F90_CreateArray1DI8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DI8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DI8(a_t)
      use F90_ArrayTypes
      type(F90_Array1DI8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DI8
  end interface
  type(F90_Array1DI8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DI8(a_t)
end subroutine F90_DestroyArray1DI8


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DL1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DL1(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DL1_t), intent(out) :: dest
      type(F90_Array1DL1_t), intent(in) :: src
    end subroutine F90_CopyDesc1DL1
  end interface
  type(F90_Array1DL1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  logical(kind=IKIND1), pointer :: a(:)
  type(F90_Array1DL1_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DL1(ptr, a_t)
end subroutine F90_CreateArray1DL1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DL1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DL1(a_t)
      use F90_ArrayTypes
      type(F90_Array1DL1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DL1
  end interface
  type(F90_Array1DL1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DL1(a_t)
end subroutine F90_DestroyArray1DL1


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DL2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DL2(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DL2_t), intent(out) :: dest
      type(F90_Array1DL2_t), intent(in) :: src
    end subroutine F90_CopyDesc1DL2
  end interface
  type(F90_Array1DL2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  logical(kind=IKIND2), pointer :: a(:)
  type(F90_Array1DL2_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DL2(ptr, a_t)
end subroutine F90_CreateArray1DL2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DL2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DL2(a_t)
      use F90_ArrayTypes
      type(F90_Array1DL2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DL2
  end interface
  type(F90_Array1DL2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DL2(a_t)
end subroutine F90_DestroyArray1DL2


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DL(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DL(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DL_t), intent(out) :: dest
      type(F90_Array1DL_t), intent(in) :: src
    end subroutine F90_CopyDesc1DL
  end interface
  type(F90_Array1DL_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  logical, pointer :: a(:)
  type(F90_Array1DL_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DL(ptr, a_t)
end subroutine F90_CreateArray1DL

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DL(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DL(a_t)
      use F90_ArrayTypes
      type(F90_Array1DL_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DL
  end interface
  type(F90_Array1DL_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DL(a_t)
end subroutine F90_DestroyArray1DL


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DL4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DL4(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DL4_t), intent(out) :: dest
      type(F90_Array1DL4_t), intent(in) :: src
    end subroutine F90_CopyDesc1DL4
  end interface
  type(F90_Array1DL4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  logical(kind=IKIND4), pointer :: a(:)
  type(F90_Array1DL4_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DL4(ptr, a_t)
end subroutine F90_CreateArray1DL4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DL4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DL4(a_t)
      use F90_ArrayTypes
      type(F90_Array1DL4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DL4
  end interface
  type(F90_Array1DL4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DL4(a_t)
end subroutine F90_DestroyArray1DL4


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DL8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DL8(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DL8_t), intent(out) :: dest
      type(F90_Array1DL8_t), intent(in) :: src
    end subroutine F90_CopyDesc1DL8
  end interface
  type(F90_Array1DL8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  logical(kind=IKIND8), pointer :: a(:)
  type(F90_Array1DL8_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DL8(ptr, a_t)
end subroutine F90_CreateArray1DL8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DL8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DL8(a_t)
      use F90_ArrayTypes
      type(F90_Array1DL8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DL8
  end interface
  type(F90_Array1DL8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DL8(a_t)
end subroutine F90_DestroyArray1DL8


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DR(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DR(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DR_t), intent(out) :: dest
      type(F90_Array1DR_t), intent(in) :: src
    end subroutine F90_CopyDesc1DR
  end interface
  type(F90_Array1DR_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  real, pointer :: a(:)
  type(F90_Array1DR_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DR(ptr, a_t)
end subroutine F90_CreateArray1DR

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DR(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DR(a_t)
      use F90_ArrayTypes
      type(F90_Array1DR_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DR
  end interface
  type(F90_Array1DR_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DR(a_t)
end subroutine F90_DestroyArray1DR


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DD(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DD(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DD_t), intent(out) :: dest
      type(F90_Array1DD_t), intent(in) :: src
    end subroutine F90_CopyDesc1DD
  end interface
  type(F90_Array1DD_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  real(kind(1.0D0)), pointer :: a(:)
  type(F90_Array1DD_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DD(ptr, a_t)
end subroutine F90_CreateArray1DD

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DD(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DD(a_t)
      use F90_ArrayTypes
      type(F90_Array1DD_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DD
  end interface
  type(F90_Array1DD_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DD(a_t)
end subroutine F90_DestroyArray1DD


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DC(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DC_t), intent(out) :: dest
      type(F90_Array1DC_t), intent(in) :: src
    end subroutine F90_CopyDesc1DC
  end interface
  type(F90_Array1DC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  complex, pointer :: a(:)
  type(F90_Array1DC_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DC(ptr, a_t)
end subroutine F90_CreateArray1DC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DC(a_t)
      use F90_ArrayTypes
      type(F90_Array1DC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DC
  end interface
  type(F90_Array1DC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DC(a_t)
end subroutine F90_DestroyArray1DC


!--------------------------------------------------------------------------
subroutine F90_CreateArray1DDC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc1DDC(dest, src)
      use F90_ArrayTypes
      type(F90_Array1DDC_t), intent(out) :: dest
      type(F90_Array1DDC_t), intent(in) :: src
    end subroutine F90_CopyDesc1DDC
  end interface
  type(F90_Array1DDC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(1), ub(1)
  complex(kind(1.0D0)), pointer :: a(:)
  type(F90_Array1DDC_t) :: a_t

  allocate( a(lb(1):ub(1)) )
  a_t%data => a
  call F90_CopyDesc1DDC(ptr, a_t)
end subroutine F90_CreateArray1DDC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray1DDC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc1DDC(a_t)
      use F90_ArrayTypes
      type(F90_Array1DDC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc1DDC
  end interface
  type(F90_Array1DDC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc1DDC(a_t)
end subroutine F90_DestroyArray1DDC


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DI1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DI1(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DI1_t), intent(out) :: dest
      type(F90_Array2DI1_t), intent(in) :: src
    end subroutine F90_CopyDesc2DI1
  end interface
  type(F90_Array2DI1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  integer(kind=IKIND1), pointer :: a(:,:)
  type(F90_Array2DI1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DI1(ptr, a_t)
end subroutine F90_CreateArray2DI1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DI1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DI1(a_t)
      use F90_ArrayTypes
      type(F90_Array2DI1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DI1
  end interface
  type(F90_Array2DI1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DI1(a_t)
end subroutine F90_DestroyArray2DI1


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DI2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DI2(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DI2_t), intent(out) :: dest
      type(F90_Array2DI2_t), intent(in) :: src
    end subroutine F90_CopyDesc2DI2
  end interface
  type(F90_Array2DI2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  integer(kind=IKIND2), pointer :: a(:,:)
  type(F90_Array2DI2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DI2(ptr, a_t)
end subroutine F90_CreateArray2DI2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DI2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DI2(a_t)
      use F90_ArrayTypes
      type(F90_Array2DI2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DI2
  end interface
  type(F90_Array2DI2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DI2(a_t)
end subroutine F90_DestroyArray2DI2


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DI(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DI(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DI_t), intent(out) :: dest
      type(F90_Array2DI_t), intent(in) :: src
    end subroutine F90_CopyDesc2DI
  end interface
  type(F90_Array2DI_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  integer, pointer :: a(:,:)
  type(F90_Array2DI_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DI(ptr, a_t)
end subroutine F90_CreateArray2DI

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DI(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DI(a_t)
      use F90_ArrayTypes
      type(F90_Array2DI_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DI
  end interface
  type(F90_Array2DI_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DI(a_t)
end subroutine F90_DestroyArray2DI


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DI4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DI4(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DI4_t), intent(out) :: dest
      type(F90_Array2DI4_t), intent(in) :: src
    end subroutine F90_CopyDesc2DI4
  end interface
  type(F90_Array2DI4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  integer(kind=IKIND4), pointer :: a(:,:)
  type(F90_Array2DI4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DI4(ptr, a_t)
end subroutine F90_CreateArray2DI4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DI4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DI4(a_t)
      use F90_ArrayTypes
      type(F90_Array2DI4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DI4
  end interface
  type(F90_Array2DI4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DI4(a_t)
end subroutine F90_DestroyArray2DI4


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DI8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DI8(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DI8_t), intent(out) :: dest
      type(F90_Array2DI8_t), intent(in) :: src
    end subroutine F90_CopyDesc2DI8
  end interface
  type(F90_Array2DI8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  integer(kind=IKIND8), pointer :: a(:,:)
  type(F90_Array2DI8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DI8(ptr, a_t)
end subroutine F90_CreateArray2DI8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DI8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DI8(a_t)
      use F90_ArrayTypes
      type(F90_Array2DI8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DI8
  end interface
  type(F90_Array2DI8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DI8(a_t)
end subroutine F90_DestroyArray2DI8


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DL1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DL1(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DL1_t), intent(out) :: dest
      type(F90_Array2DL1_t), intent(in) :: src
    end subroutine F90_CopyDesc2DL1
  end interface
  type(F90_Array2DL1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  logical(kind=IKIND1), pointer :: a(:,:)
  type(F90_Array2DL1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DL1(ptr, a_t)
end subroutine F90_CreateArray2DL1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DL1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DL1(a_t)
      use F90_ArrayTypes
      type(F90_Array2DL1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DL1
  end interface
  type(F90_Array2DL1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DL1(a_t)
end subroutine F90_DestroyArray2DL1


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DL2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DL2(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DL2_t), intent(out) :: dest
      type(F90_Array2DL2_t), intent(in) :: src
    end subroutine F90_CopyDesc2DL2
  end interface
  type(F90_Array2DL2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  logical(kind=IKIND2), pointer :: a(:,:)
  type(F90_Array2DL2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DL2(ptr, a_t)
end subroutine F90_CreateArray2DL2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DL2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DL2(a_t)
      use F90_ArrayTypes
      type(F90_Array2DL2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DL2
  end interface
  type(F90_Array2DL2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DL2(a_t)
end subroutine F90_DestroyArray2DL2


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DL(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DL(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DL_t), intent(out) :: dest
      type(F90_Array2DL_t), intent(in) :: src
    end subroutine F90_CopyDesc2DL
  end interface
  type(F90_Array2DL_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  logical, pointer :: a(:,:)
  type(F90_Array2DL_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DL(ptr, a_t)
end subroutine F90_CreateArray2DL

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DL(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DL(a_t)
      use F90_ArrayTypes
      type(F90_Array2DL_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DL
  end interface
  type(F90_Array2DL_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DL(a_t)
end subroutine F90_DestroyArray2DL


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DL4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DL4(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DL4_t), intent(out) :: dest
      type(F90_Array2DL4_t), intent(in) :: src
    end subroutine F90_CopyDesc2DL4
  end interface
  type(F90_Array2DL4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  logical(kind=IKIND4), pointer :: a(:,:)
  type(F90_Array2DL4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DL4(ptr, a_t)
end subroutine F90_CreateArray2DL4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DL4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DL4(a_t)
      use F90_ArrayTypes
      type(F90_Array2DL4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DL4
  end interface
  type(F90_Array2DL4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DL4(a_t)
end subroutine F90_DestroyArray2DL4


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DL8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DL8(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DL8_t), intent(out) :: dest
      type(F90_Array2DL8_t), intent(in) :: src
    end subroutine F90_CopyDesc2DL8
  end interface
  type(F90_Array2DL8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  logical(kind=IKIND8), pointer :: a(:,:)
  type(F90_Array2DL8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DL8(ptr, a_t)
end subroutine F90_CreateArray2DL8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DL8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DL8(a_t)
      use F90_ArrayTypes
      type(F90_Array2DL8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DL8
  end interface
  type(F90_Array2DL8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DL8(a_t)
end subroutine F90_DestroyArray2DL8


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DR(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DR(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DR_t), intent(out) :: dest
      type(F90_Array2DR_t), intent(in) :: src
    end subroutine F90_CopyDesc2DR
  end interface
  type(F90_Array2DR_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  real, pointer :: a(:,:)
  type(F90_Array2DR_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DR(ptr, a_t)
end subroutine F90_CreateArray2DR

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DR(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DR(a_t)
      use F90_ArrayTypes
      type(F90_Array2DR_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DR
  end interface
  type(F90_Array2DR_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DR(a_t)
end subroutine F90_DestroyArray2DR


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DD(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DD(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DD_t), intent(out) :: dest
      type(F90_Array2DD_t), intent(in) :: src
    end subroutine F90_CopyDesc2DD
  end interface
  type(F90_Array2DD_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  real(kind(1.0D0)), pointer :: a(:,:)
  type(F90_Array2DD_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DD(ptr, a_t)
end subroutine F90_CreateArray2DD

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DD(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DD(a_t)
      use F90_ArrayTypes
      type(F90_Array2DD_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DD
  end interface
  type(F90_Array2DD_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DD(a_t)
end subroutine F90_DestroyArray2DD


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DC(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DC_t), intent(out) :: dest
      type(F90_Array2DC_t), intent(in) :: src
    end subroutine F90_CopyDesc2DC
  end interface
  type(F90_Array2DC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  complex, pointer :: a(:,:)
  type(F90_Array2DC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DC(ptr, a_t)
end subroutine F90_CreateArray2DC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DC(a_t)
      use F90_ArrayTypes
      type(F90_Array2DC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DC
  end interface
  type(F90_Array2DC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DC(a_t)
end subroutine F90_DestroyArray2DC


!--------------------------------------------------------------------------
subroutine F90_CreateArray2DDC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc2DDC(dest, src)
      use F90_ArrayTypes
      type(F90_Array2DDC_t), intent(out) :: dest
      type(F90_Array2DDC_t), intent(in) :: src
    end subroutine F90_CopyDesc2DDC
  end interface
  type(F90_Array2DDC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(2), ub(2)
  complex(kind(1.0D0)), pointer :: a(:,:)
  type(F90_Array2DDC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2)) )
  a_t%data => a
  call F90_CopyDesc2DDC(ptr, a_t)
end subroutine F90_CreateArray2DDC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray2DDC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc2DDC(a_t)
      use F90_ArrayTypes
      type(F90_Array2DDC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc2DDC
  end interface
  type(F90_Array2DDC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc2DDC(a_t)
end subroutine F90_DestroyArray2DDC


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DI1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DI1(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DI1_t), intent(out) :: dest
      type(F90_Array3DI1_t), intent(in) :: src
    end subroutine F90_CopyDesc3DI1
  end interface
  type(F90_Array3DI1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  integer(kind=IKIND1), pointer :: a(:,:,:)
  type(F90_Array3DI1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DI1(ptr, a_t)
end subroutine F90_CreateArray3DI1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DI1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DI1(a_t)
      use F90_ArrayTypes
      type(F90_Array3DI1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DI1
  end interface
  type(F90_Array3DI1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DI1(a_t)
end subroutine F90_DestroyArray3DI1


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DI2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DI2(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DI2_t), intent(out) :: dest
      type(F90_Array3DI2_t), intent(in) :: src
    end subroutine F90_CopyDesc3DI2
  end interface
  type(F90_Array3DI2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  integer(kind=IKIND2), pointer :: a(:,:,:)
  type(F90_Array3DI2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DI2(ptr, a_t)
end subroutine F90_CreateArray3DI2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DI2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DI2(a_t)
      use F90_ArrayTypes
      type(F90_Array3DI2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DI2
  end interface
  type(F90_Array3DI2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DI2(a_t)
end subroutine F90_DestroyArray3DI2


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DI(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DI(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DI_t), intent(out) :: dest
      type(F90_Array3DI_t), intent(in) :: src
    end subroutine F90_CopyDesc3DI
  end interface
  type(F90_Array3DI_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  integer, pointer :: a(:,:,:)
  type(F90_Array3DI_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DI(ptr, a_t)
end subroutine F90_CreateArray3DI

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DI(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DI(a_t)
      use F90_ArrayTypes
      type(F90_Array3DI_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DI
  end interface
  type(F90_Array3DI_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DI(a_t)
end subroutine F90_DestroyArray3DI


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DI4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DI4(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DI4_t), intent(out) :: dest
      type(F90_Array3DI4_t), intent(in) :: src
    end subroutine F90_CopyDesc3DI4
  end interface
  type(F90_Array3DI4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  integer(kind=IKIND4), pointer :: a(:,:,:)
  type(F90_Array3DI4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DI4(ptr, a_t)
end subroutine F90_CreateArray3DI4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DI4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DI4(a_t)
      use F90_ArrayTypes
      type(F90_Array3DI4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DI4
  end interface
  type(F90_Array3DI4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DI4(a_t)
end subroutine F90_DestroyArray3DI4


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DI8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DI8(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DI8_t), intent(out) :: dest
      type(F90_Array3DI8_t), intent(in) :: src
    end subroutine F90_CopyDesc3DI8
  end interface
  type(F90_Array3DI8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  integer(kind=IKIND8), pointer :: a(:,:,:)
  type(F90_Array3DI8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DI8(ptr, a_t)
end subroutine F90_CreateArray3DI8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DI8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DI8(a_t)
      use F90_ArrayTypes
      type(F90_Array3DI8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DI8
  end interface
  type(F90_Array3DI8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DI8(a_t)
end subroutine F90_DestroyArray3DI8


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DL1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DL1(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DL1_t), intent(out) :: dest
      type(F90_Array3DL1_t), intent(in) :: src
    end subroutine F90_CopyDesc3DL1
  end interface
  type(F90_Array3DL1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  logical(kind=IKIND1), pointer :: a(:,:,:)
  type(F90_Array3DL1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DL1(ptr, a_t)
end subroutine F90_CreateArray3DL1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DL1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DL1(a_t)
      use F90_ArrayTypes
      type(F90_Array3DL1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DL1
  end interface
  type(F90_Array3DL1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DL1(a_t)
end subroutine F90_DestroyArray3DL1


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DL2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DL2(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DL2_t), intent(out) :: dest
      type(F90_Array3DL2_t), intent(in) :: src
    end subroutine F90_CopyDesc3DL2
  end interface
  type(F90_Array3DL2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  logical(kind=IKIND2), pointer :: a(:,:,:)
  type(F90_Array3DL2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DL2(ptr, a_t)
end subroutine F90_CreateArray3DL2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DL2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DL2(a_t)
      use F90_ArrayTypes
      type(F90_Array3DL2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DL2
  end interface
  type(F90_Array3DL2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DL2(a_t)
end subroutine F90_DestroyArray3DL2


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DL(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DL(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DL_t), intent(out) :: dest
      type(F90_Array3DL_t), intent(in) :: src
    end subroutine F90_CopyDesc3DL
  end interface
  type(F90_Array3DL_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  logical, pointer :: a(:,:,:)
  type(F90_Array3DL_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DL(ptr, a_t)
end subroutine F90_CreateArray3DL

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DL(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DL(a_t)
      use F90_ArrayTypes
      type(F90_Array3DL_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DL
  end interface
  type(F90_Array3DL_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DL(a_t)
end subroutine F90_DestroyArray3DL


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DL4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DL4(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DL4_t), intent(out) :: dest
      type(F90_Array3DL4_t), intent(in) :: src
    end subroutine F90_CopyDesc3DL4
  end interface
  type(F90_Array3DL4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  logical(kind=IKIND4), pointer :: a(:,:,:)
  type(F90_Array3DL4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DL4(ptr, a_t)
end subroutine F90_CreateArray3DL4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DL4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DL4(a_t)
      use F90_ArrayTypes
      type(F90_Array3DL4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DL4
  end interface
  type(F90_Array3DL4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DL4(a_t)
end subroutine F90_DestroyArray3DL4


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DL8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DL8(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DL8_t), intent(out) :: dest
      type(F90_Array3DL8_t), intent(in) :: src
    end subroutine F90_CopyDesc3DL8
  end interface
  type(F90_Array3DL8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  logical(kind=IKIND8), pointer :: a(:,:,:)
  type(F90_Array3DL8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DL8(ptr, a_t)
end subroutine F90_CreateArray3DL8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DL8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DL8(a_t)
      use F90_ArrayTypes
      type(F90_Array3DL8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DL8
  end interface
  type(F90_Array3DL8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DL8(a_t)
end subroutine F90_DestroyArray3DL8


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DR(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DR(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DR_t), intent(out) :: dest
      type(F90_Array3DR_t), intent(in) :: src
    end subroutine F90_CopyDesc3DR
  end interface
  type(F90_Array3DR_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  real, pointer :: a(:,:,:)
  type(F90_Array3DR_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DR(ptr, a_t)
end subroutine F90_CreateArray3DR

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DR(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DR(a_t)
      use F90_ArrayTypes
      type(F90_Array3DR_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DR
  end interface
  type(F90_Array3DR_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DR(a_t)
end subroutine F90_DestroyArray3DR


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DD(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DD(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DD_t), intent(out) :: dest
      type(F90_Array3DD_t), intent(in) :: src
    end subroutine F90_CopyDesc3DD
  end interface
  type(F90_Array3DD_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  real(kind(1.0D0)), pointer :: a(:,:,:)
  type(F90_Array3DD_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DD(ptr, a_t)
end subroutine F90_CreateArray3DD

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DD(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DD(a_t)
      use F90_ArrayTypes
      type(F90_Array3DD_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DD
  end interface
  type(F90_Array3DD_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DD(a_t)
end subroutine F90_DestroyArray3DD


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DC(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DC_t), intent(out) :: dest
      type(F90_Array3DC_t), intent(in) :: src
    end subroutine F90_CopyDesc3DC
  end interface
  type(F90_Array3DC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  complex, pointer :: a(:,:,:)
  type(F90_Array3DC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DC(ptr, a_t)
end subroutine F90_CreateArray3DC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DC(a_t)
      use F90_ArrayTypes
      type(F90_Array3DC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DC
  end interface
  type(F90_Array3DC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DC(a_t)
end subroutine F90_DestroyArray3DC


!--------------------------------------------------------------------------
subroutine F90_CreateArray3DDC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc3DDC(dest, src)
      use F90_ArrayTypes
      type(F90_Array3DDC_t), intent(out) :: dest
      type(F90_Array3DDC_t), intent(in) :: src
    end subroutine F90_CopyDesc3DDC
  end interface
  type(F90_Array3DDC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(3), ub(3)
  complex(kind(1.0D0)), pointer :: a(:,:,:)
  type(F90_Array3DDC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3)) )
  a_t%data => a
  call F90_CopyDesc3DDC(ptr, a_t)
end subroutine F90_CreateArray3DDC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray3DDC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc3DDC(a_t)
      use F90_ArrayTypes
      type(F90_Array3DDC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc3DDC
  end interface
  type(F90_Array3DDC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc3DDC(a_t)
end subroutine F90_DestroyArray3DDC


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DI1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DI1(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DI1_t), intent(out) :: dest
      type(F90_Array4DI1_t), intent(in) :: src
    end subroutine F90_CopyDesc4DI1
  end interface
  type(F90_Array4DI1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  integer(kind=IKIND1), pointer :: a(:,:,:,:)
  type(F90_Array4DI1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DI1(ptr, a_t)
end subroutine F90_CreateArray4DI1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DI1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DI1(a_t)
      use F90_ArrayTypes
      type(F90_Array4DI1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DI1
  end interface
  type(F90_Array4DI1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DI1(a_t)
end subroutine F90_DestroyArray4DI1


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DI2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DI2(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DI2_t), intent(out) :: dest
      type(F90_Array4DI2_t), intent(in) :: src
    end subroutine F90_CopyDesc4DI2
  end interface
  type(F90_Array4DI2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  integer(kind=IKIND2), pointer :: a(:,:,:,:)
  type(F90_Array4DI2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DI2(ptr, a_t)
end subroutine F90_CreateArray4DI2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DI2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DI2(a_t)
      use F90_ArrayTypes
      type(F90_Array4DI2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DI2
  end interface
  type(F90_Array4DI2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DI2(a_t)
end subroutine F90_DestroyArray4DI2


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DI(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DI(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DI_t), intent(out) :: dest
      type(F90_Array4DI_t), intent(in) :: src
    end subroutine F90_CopyDesc4DI
  end interface
  type(F90_Array4DI_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  integer, pointer :: a(:,:,:,:)
  type(F90_Array4DI_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DI(ptr, a_t)
end subroutine F90_CreateArray4DI

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DI(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DI(a_t)
      use F90_ArrayTypes
      type(F90_Array4DI_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DI
  end interface
  type(F90_Array4DI_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DI(a_t)
end subroutine F90_DestroyArray4DI


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DI4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DI4(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DI4_t), intent(out) :: dest
      type(F90_Array4DI4_t), intent(in) :: src
    end subroutine F90_CopyDesc4DI4
  end interface
  type(F90_Array4DI4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  integer(kind=IKIND4), pointer :: a(:,:,:,:)
  type(F90_Array4DI4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DI4(ptr, a_t)
end subroutine F90_CreateArray4DI4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DI4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DI4(a_t)
      use F90_ArrayTypes
      type(F90_Array4DI4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DI4
  end interface
  type(F90_Array4DI4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DI4(a_t)
end subroutine F90_DestroyArray4DI4


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DI8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DI8(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DI8_t), intent(out) :: dest
      type(F90_Array4DI8_t), intent(in) :: src
    end subroutine F90_CopyDesc4DI8
  end interface
  type(F90_Array4DI8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  integer(kind=IKIND8), pointer :: a(:,:,:,:)
  type(F90_Array4DI8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DI8(ptr, a_t)
end subroutine F90_CreateArray4DI8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DI8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DI8(a_t)
      use F90_ArrayTypes
      type(F90_Array4DI8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DI8
  end interface
  type(F90_Array4DI8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DI8(a_t)
end subroutine F90_DestroyArray4DI8


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DL1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DL1(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DL1_t), intent(out) :: dest
      type(F90_Array4DL1_t), intent(in) :: src
    end subroutine F90_CopyDesc4DL1
  end interface
  type(F90_Array4DL1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  logical(kind=IKIND1), pointer :: a(:,:,:,:)
  type(F90_Array4DL1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DL1(ptr, a_t)
end subroutine F90_CreateArray4DL1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DL1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DL1(a_t)
      use F90_ArrayTypes
      type(F90_Array4DL1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DL1
  end interface
  type(F90_Array4DL1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DL1(a_t)
end subroutine F90_DestroyArray4DL1


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DL2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DL2(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DL2_t), intent(out) :: dest
      type(F90_Array4DL2_t), intent(in) :: src
    end subroutine F90_CopyDesc4DL2
  end interface
  type(F90_Array4DL2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  logical(kind=IKIND2), pointer :: a(:,:,:,:)
  type(F90_Array4DL2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DL2(ptr, a_t)
end subroutine F90_CreateArray4DL2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DL2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DL2(a_t)
      use F90_ArrayTypes
      type(F90_Array4DL2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DL2
  end interface
  type(F90_Array4DL2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DL2(a_t)
end subroutine F90_DestroyArray4DL2


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DL(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DL(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DL_t), intent(out) :: dest
      type(F90_Array4DL_t), intent(in) :: src
    end subroutine F90_CopyDesc4DL
  end interface
  type(F90_Array4DL_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  logical, pointer :: a(:,:,:,:)
  type(F90_Array4DL_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DL(ptr, a_t)
end subroutine F90_CreateArray4DL

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DL(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DL(a_t)
      use F90_ArrayTypes
      type(F90_Array4DL_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DL
  end interface
  type(F90_Array4DL_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DL(a_t)
end subroutine F90_DestroyArray4DL


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DL4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DL4(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DL4_t), intent(out) :: dest
      type(F90_Array4DL4_t), intent(in) :: src
    end subroutine F90_CopyDesc4DL4
  end interface
  type(F90_Array4DL4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  logical(kind=IKIND4), pointer :: a(:,:,:,:)
  type(F90_Array4DL4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DL4(ptr, a_t)
end subroutine F90_CreateArray4DL4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DL4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DL4(a_t)
      use F90_ArrayTypes
      type(F90_Array4DL4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DL4
  end interface
  type(F90_Array4DL4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DL4(a_t)
end subroutine F90_DestroyArray4DL4


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DL8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DL8(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DL8_t), intent(out) :: dest
      type(F90_Array4DL8_t), intent(in) :: src
    end subroutine F90_CopyDesc4DL8
  end interface
  type(F90_Array4DL8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  logical(kind=IKIND8), pointer :: a(:,:,:,:)
  type(F90_Array4DL8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DL8(ptr, a_t)
end subroutine F90_CreateArray4DL8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DL8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DL8(a_t)
      use F90_ArrayTypes
      type(F90_Array4DL8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DL8
  end interface
  type(F90_Array4DL8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DL8(a_t)
end subroutine F90_DestroyArray4DL8


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DR(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DR(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DR_t), intent(out) :: dest
      type(F90_Array4DR_t), intent(in) :: src
    end subroutine F90_CopyDesc4DR
  end interface
  type(F90_Array4DR_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  real, pointer :: a(:,:,:,:)
  type(F90_Array4DR_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DR(ptr, a_t)
end subroutine F90_CreateArray4DR

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DR(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DR(a_t)
      use F90_ArrayTypes
      type(F90_Array4DR_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DR
  end interface
  type(F90_Array4DR_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DR(a_t)
end subroutine F90_DestroyArray4DR


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DD(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DD(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DD_t), intent(out) :: dest
      type(F90_Array4DD_t), intent(in) :: src
    end subroutine F90_CopyDesc4DD
  end interface
  type(F90_Array4DD_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  real(kind(1.0D0)), pointer :: a(:,:,:,:)
  type(F90_Array4DD_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DD(ptr, a_t)
end subroutine F90_CreateArray4DD

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DD(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DD(a_t)
      use F90_ArrayTypes
      type(F90_Array4DD_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DD
  end interface
  type(F90_Array4DD_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DD(a_t)
end subroutine F90_DestroyArray4DD


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DC(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DC_t), intent(out) :: dest
      type(F90_Array4DC_t), intent(in) :: src
    end subroutine F90_CopyDesc4DC
  end interface
  type(F90_Array4DC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  complex, pointer :: a(:,:,:,:)
  type(F90_Array4DC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DC(ptr, a_t)
end subroutine F90_CreateArray4DC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DC(a_t)
      use F90_ArrayTypes
      type(F90_Array4DC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DC
  end interface
  type(F90_Array4DC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DC(a_t)
end subroutine F90_DestroyArray4DC


!--------------------------------------------------------------------------
subroutine F90_CreateArray4DDC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc4DDC(dest, src)
      use F90_ArrayTypes
      type(F90_Array4DDC_t), intent(out) :: dest
      type(F90_Array4DDC_t), intent(in) :: src
    end subroutine F90_CopyDesc4DDC
  end interface
  type(F90_Array4DDC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(4), ub(4)
  complex(kind(1.0D0)), pointer :: a(:,:,:,:)
  type(F90_Array4DDC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4)) )
  a_t%data => a
  call F90_CopyDesc4DDC(ptr, a_t)
end subroutine F90_CreateArray4DDC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray4DDC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc4DDC(a_t)
      use F90_ArrayTypes
      type(F90_Array4DDC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc4DDC
  end interface
  type(F90_Array4DDC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc4DDC(a_t)
end subroutine F90_DestroyArray4DDC


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DI1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DI1(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DI1_t), intent(out) :: dest
      type(F90_Array5DI1_t), intent(in) :: src
    end subroutine F90_CopyDesc5DI1
  end interface
  type(F90_Array5DI1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:)
  type(F90_Array5DI1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DI1(ptr, a_t)
end subroutine F90_CreateArray5DI1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DI1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DI1(a_t)
      use F90_ArrayTypes
      type(F90_Array5DI1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DI1
  end interface
  type(F90_Array5DI1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DI1(a_t)
end subroutine F90_DestroyArray5DI1


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DI2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DI2(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DI2_t), intent(out) :: dest
      type(F90_Array5DI2_t), intent(in) :: src
    end subroutine F90_CopyDesc5DI2
  end interface
  type(F90_Array5DI2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:)
  type(F90_Array5DI2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DI2(ptr, a_t)
end subroutine F90_CreateArray5DI2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DI2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DI2(a_t)
      use F90_ArrayTypes
      type(F90_Array5DI2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DI2
  end interface
  type(F90_Array5DI2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DI2(a_t)
end subroutine F90_DestroyArray5DI2


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DI(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DI(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DI_t), intent(out) :: dest
      type(F90_Array5DI_t), intent(in) :: src
    end subroutine F90_CopyDesc5DI
  end interface
  type(F90_Array5DI_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  integer, pointer :: a(:,:,:,:,:)
  type(F90_Array5DI_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DI(ptr, a_t)
end subroutine F90_CreateArray5DI

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DI(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DI(a_t)
      use F90_ArrayTypes
      type(F90_Array5DI_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DI
  end interface
  type(F90_Array5DI_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DI(a_t)
end subroutine F90_DestroyArray5DI


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DI4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DI4(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DI4_t), intent(out) :: dest
      type(F90_Array5DI4_t), intent(in) :: src
    end subroutine F90_CopyDesc5DI4
  end interface
  type(F90_Array5DI4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  integer(kind=IKIND4), pointer :: a(:,:,:,:,:)
  type(F90_Array5DI4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DI4(ptr, a_t)
end subroutine F90_CreateArray5DI4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DI4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DI4(a_t)
      use F90_ArrayTypes
      type(F90_Array5DI4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DI4
  end interface
  type(F90_Array5DI4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DI4(a_t)
end subroutine F90_DestroyArray5DI4


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DI8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DI8(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DI8_t), intent(out) :: dest
      type(F90_Array5DI8_t), intent(in) :: src
    end subroutine F90_CopyDesc5DI8
  end interface
  type(F90_Array5DI8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:)
  type(F90_Array5DI8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DI8(ptr, a_t)
end subroutine F90_CreateArray5DI8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DI8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DI8(a_t)
      use F90_ArrayTypes
      type(F90_Array5DI8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DI8
  end interface
  type(F90_Array5DI8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DI8(a_t)
end subroutine F90_DestroyArray5DI8


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DL1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DL1(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DL1_t), intent(out) :: dest
      type(F90_Array5DL1_t), intent(in) :: src
    end subroutine F90_CopyDesc5DL1
  end interface
  type(F90_Array5DL1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  logical(kind=IKIND1), pointer :: a(:,:,:,:,:)
  type(F90_Array5DL1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DL1(ptr, a_t)
end subroutine F90_CreateArray5DL1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DL1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DL1(a_t)
      use F90_ArrayTypes
      type(F90_Array5DL1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DL1
  end interface
  type(F90_Array5DL1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DL1(a_t)
end subroutine F90_DestroyArray5DL1


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DL2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DL2(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DL2_t), intent(out) :: dest
      type(F90_Array5DL2_t), intent(in) :: src
    end subroutine F90_CopyDesc5DL2
  end interface
  type(F90_Array5DL2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  logical(kind=IKIND2), pointer :: a(:,:,:,:,:)
  type(F90_Array5DL2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DL2(ptr, a_t)
end subroutine F90_CreateArray5DL2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DL2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DL2(a_t)
      use F90_ArrayTypes
      type(F90_Array5DL2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DL2
  end interface
  type(F90_Array5DL2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DL2(a_t)
end subroutine F90_DestroyArray5DL2


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DL(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DL(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DL_t), intent(out) :: dest
      type(F90_Array5DL_t), intent(in) :: src
    end subroutine F90_CopyDesc5DL
  end interface
  type(F90_Array5DL_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  logical, pointer :: a(:,:,:,:,:)
  type(F90_Array5DL_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DL(ptr, a_t)
end subroutine F90_CreateArray5DL

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DL(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DL(a_t)
      use F90_ArrayTypes
      type(F90_Array5DL_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DL
  end interface
  type(F90_Array5DL_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DL(a_t)
end subroutine F90_DestroyArray5DL


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DL4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DL4(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DL4_t), intent(out) :: dest
      type(F90_Array5DL4_t), intent(in) :: src
    end subroutine F90_CopyDesc5DL4
  end interface
  type(F90_Array5DL4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  logical(kind=IKIND4), pointer :: a(:,:,:,:,:)
  type(F90_Array5DL4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DL4(ptr, a_t)
end subroutine F90_CreateArray5DL4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DL4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DL4(a_t)
      use F90_ArrayTypes
      type(F90_Array5DL4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DL4
  end interface
  type(F90_Array5DL4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DL4(a_t)
end subroutine F90_DestroyArray5DL4


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DL8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DL8(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DL8_t), intent(out) :: dest
      type(F90_Array5DL8_t), intent(in) :: src
    end subroutine F90_CopyDesc5DL8
  end interface
  type(F90_Array5DL8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  logical(kind=IKIND8), pointer :: a(:,:,:,:,:)
  type(F90_Array5DL8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DL8(ptr, a_t)
end subroutine F90_CreateArray5DL8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DL8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DL8(a_t)
      use F90_ArrayTypes
      type(F90_Array5DL8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DL8
  end interface
  type(F90_Array5DL8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DL8(a_t)
end subroutine F90_DestroyArray5DL8


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DR(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DR(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DR_t), intent(out) :: dest
      type(F90_Array5DR_t), intent(in) :: src
    end subroutine F90_CopyDesc5DR
  end interface
  type(F90_Array5DR_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  real, pointer :: a(:,:,:,:,:)
  type(F90_Array5DR_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DR(ptr, a_t)
end subroutine F90_CreateArray5DR

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DR(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DR(a_t)
      use F90_ArrayTypes
      type(F90_Array5DR_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DR
  end interface
  type(F90_Array5DR_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DR(a_t)
end subroutine F90_DestroyArray5DR


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DD(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DD(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DD_t), intent(out) :: dest
      type(F90_Array5DD_t), intent(in) :: src
    end subroutine F90_CopyDesc5DD
  end interface
  type(F90_Array5DD_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:)
  type(F90_Array5DD_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DD(ptr, a_t)
end subroutine F90_CreateArray5DD

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DD(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DD(a_t)
      use F90_ArrayTypes
      type(F90_Array5DD_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DD
  end interface
  type(F90_Array5DD_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DD(a_t)
end subroutine F90_DestroyArray5DD


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DC(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DC_t), intent(out) :: dest
      type(F90_Array5DC_t), intent(in) :: src
    end subroutine F90_CopyDesc5DC
  end interface
  type(F90_Array5DC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  complex, pointer :: a(:,:,:,:,:)
  type(F90_Array5DC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DC(ptr, a_t)
end subroutine F90_CreateArray5DC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DC(a_t)
      use F90_ArrayTypes
      type(F90_Array5DC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DC
  end interface
  type(F90_Array5DC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DC(a_t)
end subroutine F90_DestroyArray5DC


!--------------------------------------------------------------------------
subroutine F90_CreateArray5DDC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc5DDC(dest, src)
      use F90_ArrayTypes
      type(F90_Array5DDC_t), intent(out) :: dest
      type(F90_Array5DDC_t), intent(in) :: src
    end subroutine F90_CopyDesc5DDC
  end interface
  type(F90_Array5DDC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(5), ub(5)
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:)
  type(F90_Array5DDC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5)) )
  a_t%data => a
  call F90_CopyDesc5DDC(ptr, a_t)
end subroutine F90_CreateArray5DDC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray5DDC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc5DDC(a_t)
      use F90_ArrayTypes
      type(F90_Array5DDC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc5DDC
  end interface
  type(F90_Array5DDC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc5DDC(a_t)
end subroutine F90_DestroyArray5DDC


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DI1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DI1(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DI1_t), intent(out) :: dest
      type(F90_Array6DI1_t), intent(in) :: src
    end subroutine F90_CopyDesc6DI1
  end interface
  type(F90_Array6DI1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DI1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DI1(ptr, a_t)
end subroutine F90_CreateArray6DI1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DI1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DI1(a_t)
      use F90_ArrayTypes
      type(F90_Array6DI1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DI1
  end interface
  type(F90_Array6DI1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DI1(a_t)
end subroutine F90_DestroyArray6DI1


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DI2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DI2(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DI2_t), intent(out) :: dest
      type(F90_Array6DI2_t), intent(in) :: src
    end subroutine F90_CopyDesc6DI2
  end interface
  type(F90_Array6DI2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DI2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DI2(ptr, a_t)
end subroutine F90_CreateArray6DI2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DI2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DI2(a_t)
      use F90_ArrayTypes
      type(F90_Array6DI2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DI2
  end interface
  type(F90_Array6DI2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DI2(a_t)
end subroutine F90_DestroyArray6DI2


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DI(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DI(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DI_t), intent(out) :: dest
      type(F90_Array6DI_t), intent(in) :: src
    end subroutine F90_CopyDesc6DI
  end interface
  type(F90_Array6DI_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  integer, pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DI_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DI(ptr, a_t)
end subroutine F90_CreateArray6DI

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DI(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DI(a_t)
      use F90_ArrayTypes
      type(F90_Array6DI_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DI
  end interface
  type(F90_Array6DI_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DI(a_t)
end subroutine F90_DestroyArray6DI


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DI4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DI4(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DI4_t), intent(out) :: dest
      type(F90_Array6DI4_t), intent(in) :: src
    end subroutine F90_CopyDesc6DI4
  end interface
  type(F90_Array6DI4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  integer(kind=IKIND4), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DI4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DI4(ptr, a_t)
end subroutine F90_CreateArray6DI4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DI4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DI4(a_t)
      use F90_ArrayTypes
      type(F90_Array6DI4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DI4
  end interface
  type(F90_Array6DI4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DI4(a_t)
end subroutine F90_DestroyArray6DI4


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DI8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DI8(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DI8_t), intent(out) :: dest
      type(F90_Array6DI8_t), intent(in) :: src
    end subroutine F90_CopyDesc6DI8
  end interface
  type(F90_Array6DI8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DI8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DI8(ptr, a_t)
end subroutine F90_CreateArray6DI8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DI8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DI8(a_t)
      use F90_ArrayTypes
      type(F90_Array6DI8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DI8
  end interface
  type(F90_Array6DI8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DI8(a_t)
end subroutine F90_DestroyArray6DI8


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DL1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DL1(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DL1_t), intent(out) :: dest
      type(F90_Array6DL1_t), intent(in) :: src
    end subroutine F90_CopyDesc6DL1
  end interface
  type(F90_Array6DL1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  logical(kind=IKIND1), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DL1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DL1(ptr, a_t)
end subroutine F90_CreateArray6DL1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DL1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DL1(a_t)
      use F90_ArrayTypes
      type(F90_Array6DL1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DL1
  end interface
  type(F90_Array6DL1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DL1(a_t)
end subroutine F90_DestroyArray6DL1


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DL2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DL2(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DL2_t), intent(out) :: dest
      type(F90_Array6DL2_t), intent(in) :: src
    end subroutine F90_CopyDesc6DL2
  end interface
  type(F90_Array6DL2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  logical(kind=IKIND2), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DL2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DL2(ptr, a_t)
end subroutine F90_CreateArray6DL2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DL2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DL2(a_t)
      use F90_ArrayTypes
      type(F90_Array6DL2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DL2
  end interface
  type(F90_Array6DL2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DL2(a_t)
end subroutine F90_DestroyArray6DL2


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DL(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DL(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DL_t), intent(out) :: dest
      type(F90_Array6DL_t), intent(in) :: src
    end subroutine F90_CopyDesc6DL
  end interface
  type(F90_Array6DL_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  logical, pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DL_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DL(ptr, a_t)
end subroutine F90_CreateArray6DL

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DL(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DL(a_t)
      use F90_ArrayTypes
      type(F90_Array6DL_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DL
  end interface
  type(F90_Array6DL_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DL(a_t)
end subroutine F90_DestroyArray6DL


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DL4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DL4(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DL4_t), intent(out) :: dest
      type(F90_Array6DL4_t), intent(in) :: src
    end subroutine F90_CopyDesc6DL4
  end interface
  type(F90_Array6DL4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  logical(kind=IKIND4), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DL4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DL4(ptr, a_t)
end subroutine F90_CreateArray6DL4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DL4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DL4(a_t)
      use F90_ArrayTypes
      type(F90_Array6DL4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DL4
  end interface
  type(F90_Array6DL4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DL4(a_t)
end subroutine F90_DestroyArray6DL4


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DL8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DL8(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DL8_t), intent(out) :: dest
      type(F90_Array6DL8_t), intent(in) :: src
    end subroutine F90_CopyDesc6DL8
  end interface
  type(F90_Array6DL8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  logical(kind=IKIND8), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DL8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DL8(ptr, a_t)
end subroutine F90_CreateArray6DL8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DL8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DL8(a_t)
      use F90_ArrayTypes
      type(F90_Array6DL8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DL8
  end interface
  type(F90_Array6DL8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DL8(a_t)
end subroutine F90_DestroyArray6DL8


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DR(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DR(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DR_t), intent(out) :: dest
      type(F90_Array6DR_t), intent(in) :: src
    end subroutine F90_CopyDesc6DR
  end interface
  type(F90_Array6DR_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  real, pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DR_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DR(ptr, a_t)
end subroutine F90_CreateArray6DR

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DR(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DR(a_t)
      use F90_ArrayTypes
      type(F90_Array6DR_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DR
  end interface
  type(F90_Array6DR_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DR(a_t)
end subroutine F90_DestroyArray6DR


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DD(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DD(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DD_t), intent(out) :: dest
      type(F90_Array6DD_t), intent(in) :: src
    end subroutine F90_CopyDesc6DD
  end interface
  type(F90_Array6DD_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DD_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DD(ptr, a_t)
end subroutine F90_CreateArray6DD

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DD(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DD(a_t)
      use F90_ArrayTypes
      type(F90_Array6DD_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DD
  end interface
  type(F90_Array6DD_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DD(a_t)
end subroutine F90_DestroyArray6DD


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DC(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DC_t), intent(out) :: dest
      type(F90_Array6DC_t), intent(in) :: src
    end subroutine F90_CopyDesc6DC
  end interface
  type(F90_Array6DC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  complex, pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DC(ptr, a_t)
end subroutine F90_CreateArray6DC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DC(a_t)
      use F90_ArrayTypes
      type(F90_Array6DC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DC
  end interface
  type(F90_Array6DC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DC(a_t)
end subroutine F90_DestroyArray6DC


!--------------------------------------------------------------------------
subroutine F90_CreateArray6DDC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc6DDC(dest, src)
      use F90_ArrayTypes
      type(F90_Array6DDC_t), intent(out) :: dest
      type(F90_Array6DDC_t), intent(in) :: src
    end subroutine F90_CopyDesc6DDC
  end interface
  type(F90_Array6DDC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(6), ub(6)
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:)
  type(F90_Array6DDC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6)) )
  a_t%data => a
  call F90_CopyDesc6DDC(ptr, a_t)
end subroutine F90_CreateArray6DDC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray6DDC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc6DDC(a_t)
      use F90_ArrayTypes
      type(F90_Array6DDC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc6DDC
  end interface
  type(F90_Array6DDC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc6DDC(a_t)
end subroutine F90_DestroyArray6DDC


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DI1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DI1(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DI1_t), intent(out) :: dest
      type(F90_Array7DI1_t), intent(in) :: src
    end subroutine F90_CopyDesc7DI1
  end interface
  type(F90_Array7DI1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  integer(kind=IKIND1), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DI1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DI1(ptr, a_t)
end subroutine F90_CreateArray7DI1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DI1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DI1(a_t)
      use F90_ArrayTypes
      type(F90_Array7DI1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DI1
  end interface
  type(F90_Array7DI1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DI1(a_t)
end subroutine F90_DestroyArray7DI1


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DI2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DI2(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DI2_t), intent(out) :: dest
      type(F90_Array7DI2_t), intent(in) :: src
    end subroutine F90_CopyDesc7DI2
  end interface
  type(F90_Array7DI2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  integer(kind=IKIND2), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DI2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DI2(ptr, a_t)
end subroutine F90_CreateArray7DI2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DI2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DI2(a_t)
      use F90_ArrayTypes
      type(F90_Array7DI2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DI2
  end interface
  type(F90_Array7DI2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DI2(a_t)
end subroutine F90_DestroyArray7DI2


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DI(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DI(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DI_t), intent(out) :: dest
      type(F90_Array7DI_t), intent(in) :: src
    end subroutine F90_CopyDesc7DI
  end interface
  type(F90_Array7DI_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  integer, pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DI_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DI(ptr, a_t)
end subroutine F90_CreateArray7DI

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DI(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DI(a_t)
      use F90_ArrayTypes
      type(F90_Array7DI_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DI
  end interface
  type(F90_Array7DI_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DI(a_t)
end subroutine F90_DestroyArray7DI


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DI4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DI4(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DI4_t), intent(out) :: dest
      type(F90_Array7DI4_t), intent(in) :: src
    end subroutine F90_CopyDesc7DI4
  end interface
  type(F90_Array7DI4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  integer(kind=IKIND4), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DI4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DI4(ptr, a_t)
end subroutine F90_CreateArray7DI4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DI4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DI4(a_t)
      use F90_ArrayTypes
      type(F90_Array7DI4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DI4
  end interface
  type(F90_Array7DI4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DI4(a_t)
end subroutine F90_DestroyArray7DI4


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DI8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DI8(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DI8_t), intent(out) :: dest
      type(F90_Array7DI8_t), intent(in) :: src
    end subroutine F90_CopyDesc7DI8
  end interface
  type(F90_Array7DI8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  integer(kind=IKIND8), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DI8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DI8(ptr, a_t)
end subroutine F90_CreateArray7DI8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DI8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DI8(a_t)
      use F90_ArrayTypes
      type(F90_Array7DI8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DI8
  end interface
  type(F90_Array7DI8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DI8(a_t)
end subroutine F90_DestroyArray7DI8


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DL1(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DL1(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DL1_t), intent(out) :: dest
      type(F90_Array7DL1_t), intent(in) :: src
    end subroutine F90_CopyDesc7DL1
  end interface
  type(F90_Array7DL1_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  logical(kind=IKIND1), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DL1_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DL1(ptr, a_t)
end subroutine F90_CreateArray7DL1

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DL1(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DL1(a_t)
      use F90_ArrayTypes
      type(F90_Array7DL1_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DL1
  end interface
  type(F90_Array7DL1_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DL1(a_t)
end subroutine F90_DestroyArray7DL1


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DL2(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DL2(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DL2_t), intent(out) :: dest
      type(F90_Array7DL2_t), intent(in) :: src
    end subroutine F90_CopyDesc7DL2
  end interface
  type(F90_Array7DL2_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  logical(kind=IKIND2), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DL2_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DL2(ptr, a_t)
end subroutine F90_CreateArray7DL2

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DL2(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DL2(a_t)
      use F90_ArrayTypes
      type(F90_Array7DL2_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DL2
  end interface
  type(F90_Array7DL2_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DL2(a_t)
end subroutine F90_DestroyArray7DL2


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DL(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DL(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DL_t), intent(out) :: dest
      type(F90_Array7DL_t), intent(in) :: src
    end subroutine F90_CopyDesc7DL
  end interface
  type(F90_Array7DL_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  logical, pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DL_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DL(ptr, a_t)
end subroutine F90_CreateArray7DL

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DL(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DL(a_t)
      use F90_ArrayTypes
      type(F90_Array7DL_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DL
  end interface
  type(F90_Array7DL_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DL(a_t)
end subroutine F90_DestroyArray7DL


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DL4(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DL4(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DL4_t), intent(out) :: dest
      type(F90_Array7DL4_t), intent(in) :: src
    end subroutine F90_CopyDesc7DL4
  end interface
  type(F90_Array7DL4_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  logical(kind=IKIND4), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DL4_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DL4(ptr, a_t)
end subroutine F90_CreateArray7DL4

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DL4(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DL4(a_t)
      use F90_ArrayTypes
      type(F90_Array7DL4_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DL4
  end interface
  type(F90_Array7DL4_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DL4(a_t)
end subroutine F90_DestroyArray7DL4


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DL8(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DL8(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DL8_t), intent(out) :: dest
      type(F90_Array7DL8_t), intent(in) :: src
    end subroutine F90_CopyDesc7DL8
  end interface
  type(F90_Array7DL8_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  logical(kind=IKIND8), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DL8_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DL8(ptr, a_t)
end subroutine F90_CreateArray7DL8

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DL8(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DL8(a_t)
      use F90_ArrayTypes
      type(F90_Array7DL8_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DL8
  end interface
  type(F90_Array7DL8_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DL8(a_t)
end subroutine F90_DestroyArray7DL8


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DR(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DR(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DR_t), intent(out) :: dest
      type(F90_Array7DR_t), intent(in) :: src
    end subroutine F90_CopyDesc7DR
  end interface
  type(F90_Array7DR_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  real, pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DR_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DR(ptr, a_t)
end subroutine F90_CreateArray7DR

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DR(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DR(a_t)
      use F90_ArrayTypes
      type(F90_Array7DR_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DR
  end interface
  type(F90_Array7DR_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DR(a_t)
end subroutine F90_DestroyArray7DR


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DD(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DD(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DD_t), intent(out) :: dest
      type(F90_Array7DD_t), intent(in) :: src
    end subroutine F90_CopyDesc7DD
  end interface
  type(F90_Array7DD_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  real(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DD_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DD(ptr, a_t)
end subroutine F90_CreateArray7DD

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DD(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DD(a_t)
      use F90_ArrayTypes
      type(F90_Array7DD_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DD
  end interface
  type(F90_Array7DD_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DD(a_t)
end subroutine F90_DestroyArray7DD


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DC(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DC_t), intent(out) :: dest
      type(F90_Array7DC_t), intent(in) :: src
    end subroutine F90_CopyDesc7DC
  end interface
  type(F90_Array7DC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  complex, pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DC(ptr, a_t)
end subroutine F90_CreateArray7DC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DC(a_t)
      use F90_ArrayTypes
      type(F90_Array7DC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DC
  end interface
  type(F90_Array7DC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DC(a_t)
end subroutine F90_DestroyArray7DC


!--------------------------------------------------------------------------
subroutine F90_CreateArray7DDC(ptr, lb, ub)
  use F90_kinds
  use F90_ArrayTypes
  interface
    subroutine F90_CopyDesc7DDC(dest, src)
      use F90_ArrayTypes
      type(F90_Array7DDC_t), intent(out) :: dest
      type(F90_Array7DDC_t), intent(in) :: src
    end subroutine F90_CopyDesc7DDC
  end interface
  type(F90_Array7DDC_t), intent(out) :: ptr
  integer(kind=IKIND_LONG), intent(in) :: lb(7), ub(7)
  complex(kind(1.0D0)), pointer :: a(:,:,:,:,:,:,:)
  type(F90_Array7DDC_t) :: a_t

  allocate( a(lb(1):ub(1),lb(2):ub(2),lb(3):ub(3),lb(4):ub(4),lb(5):ub(5),lb(6):ub(6),lb(7):ub(7)) )
  a_t%data => a
  call F90_CopyDesc7DDC(ptr, a_t)
end subroutine F90_CreateArray7DDC

!--------------------------------------------------------------------------
subroutine F90_DestroyArray7DDC(a_t)
  use F90_ArrayTypes
  interface
    subroutine F90_Dealloc7DDC(a_t)
      use F90_ArrayTypes
      type(F90_Array7DDC_t), intent(inout) :: a_t
    end subroutine F90_Dealloc7DDC
  end interface
  type(F90_Array7DDC_t), intent(inout) :: a_t
  deallocate(a_t%data)
  call F90_Dealloc7DDC(a_t)
end subroutine F90_DestroyArray7DDC


