module m_arrays

integer, parameter :: PADDING = 2

type array1D_PAD
  integer :: ibegin(PADDING)
  integer, pointer :: array(:)
  integer :: iend
end type array1D_PAD

type array1D
  integer :: ibegin
  integer, pointer :: array(:)
  integer :: iend
end type array1D

type array2D
  integer :: ibegin
  integer, pointer :: array(:,:)
  integer :: iend
end type array2D

type array3D
  integer :: ibegin
  integer, pointer :: array(:,:,:)
  integer :: iend
end type array3D

type array4D
  integer :: ibegin
  integer, pointer :: array(:,:,:,:)
  integer :: iend
end type array4D

type array5D
  integer :: ibegin
  integer, pointer :: array(:,:,:,:,:)
  integer :: iend
end type array5D

type array6D
  integer :: ibegin
  integer, pointer :: array(:,:,:,:,:,:)
  integer :: iend
end type array6D

type array7D
  integer :: ibegin
  integer, pointer :: array(:,:,:,:,:,:,:)
  integer :: iend
end type array7D

end module m_arrays


subroutine setArray1D_PAD(wrapper)
  use m_arrays
  type(array1D_PAD), intent(out) :: wrapper
  integer, allocatable, target :: a(:)

  allocate(a(8))
  wrapper%array => a
  wrapper%ibegin(1) = 333332
  wrapper%iend   = 333333

  if (wrapper%ibegin(1) .eq. 0) then
    print *, "Should not arrive here, need print for GNU symbols"
  end if

end subroutine setArray1D_PAD


subroutine setArray1D(wrapper)
  use m_arrays
  type(array1D), intent(out) :: wrapper
  integer, allocatable, target :: a(:)

  allocate(a(8))
  wrapper%array => a
  wrapper%ibegin = 333332
  wrapper%iend   = 333333

  if (wrapper%ibegin .eq. 0) then
    print *, "Should not arrive here, need print for GNU symbols"
  end if

end subroutine setArray1D


subroutine setArray2D(wrapper)
  use m_arrays
  type(array2D), intent(out) :: wrapper
  integer, allocatable, target :: a(:,:)

  allocate(a(8,7))
  wrapper%array => a
  wrapper%ibegin = 333332
  wrapper%iend   = 333333

end subroutine setArray2D


subroutine setArray3D(wrapper)
  use m_arrays
  type(array3D), intent(out) :: wrapper
  integer, allocatable, target :: a(:,:,:)

  allocate(a(8,7,6))
  wrapper%array => a
  wrapper%ibegin = 333332
  wrapper%iend   = 333333

end subroutine setArray3D


subroutine setArray4D(wrapper)
  use m_arrays
  type(array4D), intent(out) :: wrapper
  integer, allocatable, target :: a(:,:,:,:)

  allocate(a(8,7,6,5))
  wrapper%array => a
  wrapper%ibegin = 333332
  wrapper%iend   = 333333

end subroutine setArray4D


subroutine setArray5D(wrapper)
  use m_arrays
  type(array5D), intent(out) :: wrapper
  integer, allocatable, target :: a(:,:,:,:,:)

  allocate(a(8,7,6,5,4))
  wrapper%array => a
  wrapper%ibegin = 333332
  wrapper%iend   = 333333

end subroutine setArray5D


subroutine setArray6D(wrapper)
  use m_arrays
  type(array6D), intent(out) :: wrapper
  integer, allocatable, target :: a(:,:,:,:,:,:)

  allocate(a(8,7,6,5,4,3))
  wrapper%array => a
  wrapper%ibegin = 333332
  wrapper%iend   = 333333

end subroutine setArray6D


subroutine setArray7D(wrapper)
  use m_arrays
  type(array7D), intent(out) :: wrapper
  integer, allocatable, target :: a(:,:,:,:,:,:,:)

  allocate(a(8,7,6,5,4,3,2))
  wrapper%array => a
  wrapper%ibegin = 333332
  wrapper%iend   = 333333

end subroutine setArray7D

