!! LANL:license
! -------------------------------------------------------------------------
! This SOFTWARE has been authored by an employee or employees of the
! University of California, operator of the Los Alamos National Laboratory
! under Contract No. W-7405-ENG-36 with the U.S. Department of Energy.
! The U.S. Government has rights to use, reproduce, and distribute this
! SOFTWARE.  The public may copy, distribute, prepare derivative works and
! publicly display this SOFTWARE without charge, provided that this Notice
! and any statement of authorship are reproduced on all copies.  Neither
! the Government nor the University makes any warranty, express or implied,
! or assumes any liability or responsibility for the use of this SOFTWARE.
! If SOFTWARE is modified to produce derivative works, such modified
! SOFTWARE should be clearly marked, so as not to confuse it with the
! version available from LANL.
! -------------------------------------------------------------------------
! LANL:license
! -------------------------------------------------------------------------
!
! testArrays.f90 - this file is automatically created
!
! This file tests the F90_CreateArray/F90_DestroyArray functions in libchasm.a.
!
!!


!--------------------------------------------------------------------------
integer function testArray1DI1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DI1_t), intent(in) :: a_t
  testArray1DI1 = 0

  if (.not. associated(a_t%data)) then
    testArray1DI1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DI1: count =", sz(1), " size =", size(a_t%data)
    testArray1DI1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DI1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DI1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DI1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DI1 = 5
      return
    end if
  end do

end function testArray1DI1


!--------------------------------------------------------------------------
integer function testArray1DI2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DI2_t), intent(in) :: a_t
  testArray1DI2 = 0

  if (.not. associated(a_t%data)) then
    testArray1DI2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DI2: count =", sz(1), " size =", size(a_t%data)
    testArray1DI2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DI2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DI2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DI2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DI2 = 5
      return
    end if
  end do

end function testArray1DI2


!--------------------------------------------------------------------------
integer function testArray1DI(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DI_t), intent(in) :: a_t
  testArray1DI = 0

  if (.not. associated(a_t%data)) then
    testArray1DI = 1
    return
  end if

  if (any(a_t%data .ne. -1)) then
    print *, "ERROR testArray1DI: any(a_t%data .ne. rank)"
    testArray1DI = 2
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DI: count =", sz(1), " size =", size(a_t%data)
    testArray1DI = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DI: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DI = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DI: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DI = 5
      return
    end if
  end do

end function testArray1DI


!--------------------------------------------------------------------------
integer function testArray1DI4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DI4_t), intent(in) :: a_t
  testArray1DI4 = 0

  if (.not. associated(a_t%data)) then
    testArray1DI4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DI4: count =", sz(1), " size =", size(a_t%data)
    testArray1DI4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DI4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DI4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DI4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DI4 = 5
      return
    end if
  end do

end function testArray1DI4


!--------------------------------------------------------------------------
integer function testArray1DI8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DI8_t), intent(in) :: a_t
  testArray1DI8 = 0

  if (.not. associated(a_t%data)) then
    testArray1DI8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DI8: count =", sz(1), " size =", size(a_t%data)
    testArray1DI8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DI8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DI8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DI8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DI8 = 5
      return
    end if
  end do

end function testArray1DI8


!--------------------------------------------------------------------------
integer function testArray1DL1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DL1_t), intent(in) :: a_t
  testArray1DL1 = 0

  if (.not. associated(a_t%data)) then
    testArray1DL1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DL1: count =", sz(1), " size =", size(a_t%data)
    testArray1DL1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DL1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DL1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DL1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DL1 = 5
      return
    end if
  end do

end function testArray1DL1


!--------------------------------------------------------------------------
integer function testArray1DL2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DL2_t), intent(in) :: a_t
  testArray1DL2 = 0

  if (.not. associated(a_t%data)) then
    testArray1DL2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DL2: count =", sz(1), " size =", size(a_t%data)
    testArray1DL2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DL2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DL2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DL2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DL2 = 5
      return
    end if
  end do

end function testArray1DL2


!--------------------------------------------------------------------------
integer function testArray1DL(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DL_t), intent(in) :: a_t
  testArray1DL = 0

  if (.not. associated(a_t%data)) then
    testArray1DL = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DL: count =", sz(1), " size =", size(a_t%data)
    testArray1DL = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DL: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DL = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DL: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DL = 5
      return
    end if
  end do

end function testArray1DL


!--------------------------------------------------------------------------
integer function testArray1DL4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DL4_t), intent(in) :: a_t
  testArray1DL4 = 0

  if (.not. associated(a_t%data)) then
    testArray1DL4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DL4: count =", sz(1), " size =", size(a_t%data)
    testArray1DL4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DL4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DL4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DL4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DL4 = 5
      return
    end if
  end do

end function testArray1DL4


!--------------------------------------------------------------------------
integer function testArray1DL8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DL8_t), intent(in) :: a_t
  testArray1DL8 = 0

  if (.not. associated(a_t%data)) then
    testArray1DL8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DL8: count =", sz(1), " size =", size(a_t%data)
    testArray1DL8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DL8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DL8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DL8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DL8 = 5
      return
    end if
  end do

end function testArray1DL8


!--------------------------------------------------------------------------
integer function testArray1DR(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DR_t), intent(in) :: a_t
  testArray1DR = 0

  if (.not. associated(a_t%data)) then
    testArray1DR = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DR: count =", sz(1), " size =", size(a_t%data)
    testArray1DR = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DR: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DR = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DR: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DR = 5
      return
    end if
  end do

end function testArray1DR


!--------------------------------------------------------------------------
integer function testArray1DD(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DD_t), intent(in) :: a_t
  testArray1DD = 0

  if (.not. associated(a_t%data)) then
    testArray1DD = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DD: count =", sz(1), " size =", size(a_t%data)
    testArray1DD = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DD: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DD = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DD: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DD = 5
      return
    end if
  end do

end function testArray1DD


!--------------------------------------------------------------------------
integer function testArray1DC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DC_t), intent(in) :: a_t
  testArray1DC = 0

  if (.not. associated(a_t%data)) then
    testArray1DC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DC: count =", sz(1), " size =", size(a_t%data)
    testArray1DC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DC = 5
      return
    end if
  end do

end function testArray1DC


!--------------------------------------------------------------------------
integer function testArray1DDC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(1)
  type(F90_Array1DDC_t), intent(in) :: a_t
  testArray1DDC = 0

  if (.not. associated(a_t%data)) then
    testArray1DDC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(1)) then
    print *, "ERROR testArray1DDC: count =", sz(1), " size =", size(a_t%data)
    testArray1DDC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 1
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray1DDC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray1DDC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray1DDC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray1DDC = 5
      return
    end if
  end do

end function testArray1DDC


!--------------------------------------------------------------------------
integer function testArray2DI1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DI1_t), intent(in) :: a_t
  testArray2DI1 = 0

  if (.not. associated(a_t%data)) then
    testArray2DI1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DI1: count =", sz(2), " size =", size(a_t%data)
    testArray2DI1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DI1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DI1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DI1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DI1 = 5
      return
    end if
  end do

end function testArray2DI1


!--------------------------------------------------------------------------
integer function testArray2DI2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DI2_t), intent(in) :: a_t
  testArray2DI2 = 0

  if (.not. associated(a_t%data)) then
    testArray2DI2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DI2: count =", sz(2), " size =", size(a_t%data)
    testArray2DI2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DI2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DI2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DI2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DI2 = 5
      return
    end if
  end do

end function testArray2DI2


!--------------------------------------------------------------------------
integer function testArray2DI(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DI_t), intent(in) :: a_t
  testArray2DI = 0

  if (.not. associated(a_t%data)) then
    testArray2DI = 1
    return
  end if

  if (any(a_t%data .ne. -2)) then
    print *, "ERROR testArray2DI: any(a_t%data .ne. rank)"
    testArray2DI = 2
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DI: count =", sz(2), " size =", size(a_t%data)
    testArray2DI = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DI: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DI = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DI: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DI = 5
      return
    end if
  end do

end function testArray2DI


!--------------------------------------------------------------------------
integer function testArray2DI4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DI4_t), intent(in) :: a_t
  testArray2DI4 = 0

  if (.not. associated(a_t%data)) then
    testArray2DI4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DI4: count =", sz(2), " size =", size(a_t%data)
    testArray2DI4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DI4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DI4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DI4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DI4 = 5
      return
    end if
  end do

end function testArray2DI4


!--------------------------------------------------------------------------
integer function testArray2DI8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DI8_t), intent(in) :: a_t
  testArray2DI8 = 0

  if (.not. associated(a_t%data)) then
    testArray2DI8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DI8: count =", sz(2), " size =", size(a_t%data)
    testArray2DI8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DI8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DI8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DI8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DI8 = 5
      return
    end if
  end do

end function testArray2DI8


!--------------------------------------------------------------------------
integer function testArray2DL1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DL1_t), intent(in) :: a_t
  testArray2DL1 = 0

  if (.not. associated(a_t%data)) then
    testArray2DL1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DL1: count =", sz(2), " size =", size(a_t%data)
    testArray2DL1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DL1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DL1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DL1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DL1 = 5
      return
    end if
  end do

end function testArray2DL1


!--------------------------------------------------------------------------
integer function testArray2DL2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DL2_t), intent(in) :: a_t
  testArray2DL2 = 0

  if (.not. associated(a_t%data)) then
    testArray2DL2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DL2: count =", sz(2), " size =", size(a_t%data)
    testArray2DL2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DL2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DL2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DL2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DL2 = 5
      return
    end if
  end do

end function testArray2DL2


!--------------------------------------------------------------------------
integer function testArray2DL(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DL_t), intent(in) :: a_t
  testArray2DL = 0

  if (.not. associated(a_t%data)) then
    testArray2DL = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DL: count =", sz(2), " size =", size(a_t%data)
    testArray2DL = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DL: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DL = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DL: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DL = 5
      return
    end if
  end do

end function testArray2DL


!--------------------------------------------------------------------------
integer function testArray2DL4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DL4_t), intent(in) :: a_t
  testArray2DL4 = 0

  if (.not. associated(a_t%data)) then
    testArray2DL4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DL4: count =", sz(2), " size =", size(a_t%data)
    testArray2DL4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DL4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DL4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DL4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DL4 = 5
      return
    end if
  end do

end function testArray2DL4


!--------------------------------------------------------------------------
integer function testArray2DL8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DL8_t), intent(in) :: a_t
  testArray2DL8 = 0

  if (.not. associated(a_t%data)) then
    testArray2DL8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DL8: count =", sz(2), " size =", size(a_t%data)
    testArray2DL8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DL8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DL8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DL8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DL8 = 5
      return
    end if
  end do

end function testArray2DL8


!--------------------------------------------------------------------------
integer function testArray2DR(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DR_t), intent(in) :: a_t
  testArray2DR = 0

  if (.not. associated(a_t%data)) then
    testArray2DR = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DR: count =", sz(2), " size =", size(a_t%data)
    testArray2DR = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DR: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DR = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DR: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DR = 5
      return
    end if
  end do

end function testArray2DR


!--------------------------------------------------------------------------
integer function testArray2DD(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DD_t), intent(in) :: a_t
  testArray2DD = 0

  if (.not. associated(a_t%data)) then
    testArray2DD = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DD: count =", sz(2), " size =", size(a_t%data)
    testArray2DD = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DD: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DD = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DD: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DD = 5
      return
    end if
  end do

end function testArray2DD


!--------------------------------------------------------------------------
integer function testArray2DC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DC_t), intent(in) :: a_t
  testArray2DC = 0

  if (.not. associated(a_t%data)) then
    testArray2DC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DC: count =", sz(2), " size =", size(a_t%data)
    testArray2DC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DC = 5
      return
    end if
  end do

end function testArray2DC


!--------------------------------------------------------------------------
integer function testArray2DDC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(2)
  type(F90_Array2DDC_t), intent(in) :: a_t
  testArray2DDC = 0

  if (.not. associated(a_t%data)) then
    testArray2DDC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(2)) then
    print *, "ERROR testArray2DDC: count =", sz(2), " size =", size(a_t%data)
    testArray2DDC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 2
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray2DDC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray2DDC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray2DDC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray2DDC = 5
      return
    end if
  end do

end function testArray2DDC


!--------------------------------------------------------------------------
integer function testArray3DI1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DI1_t), intent(in) :: a_t
  testArray3DI1 = 0

  if (.not. associated(a_t%data)) then
    testArray3DI1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DI1: count =", sz(3), " size =", size(a_t%data)
    testArray3DI1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DI1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DI1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DI1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DI1 = 5
      return
    end if
  end do

end function testArray3DI1


!--------------------------------------------------------------------------
integer function testArray3DI2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DI2_t), intent(in) :: a_t
  testArray3DI2 = 0

  if (.not. associated(a_t%data)) then
    testArray3DI2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DI2: count =", sz(3), " size =", size(a_t%data)
    testArray3DI2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DI2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DI2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DI2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DI2 = 5
      return
    end if
  end do

end function testArray3DI2


!--------------------------------------------------------------------------
integer function testArray3DI(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DI_t), intent(in) :: a_t
  testArray3DI = 0

  if (.not. associated(a_t%data)) then
    testArray3DI = 1
    return
  end if

  if (any(a_t%data .ne. -3)) then
    print *, "ERROR testArray3DI: any(a_t%data .ne. rank)"
    testArray3DI = 2
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DI: count =", sz(3), " size =", size(a_t%data)
    testArray3DI = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DI: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DI = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DI: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DI = 5
      return
    end if
  end do

end function testArray3DI


!--------------------------------------------------------------------------
integer function testArray3DI4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DI4_t), intent(in) :: a_t
  testArray3DI4 = 0

  if (.not. associated(a_t%data)) then
    testArray3DI4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DI4: count =", sz(3), " size =", size(a_t%data)
    testArray3DI4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DI4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DI4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DI4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DI4 = 5
      return
    end if
  end do

end function testArray3DI4


!--------------------------------------------------------------------------
integer function testArray3DI8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DI8_t), intent(in) :: a_t
  testArray3DI8 = 0

  if (.not. associated(a_t%data)) then
    testArray3DI8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DI8: count =", sz(3), " size =", size(a_t%data)
    testArray3DI8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DI8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DI8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DI8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DI8 = 5
      return
    end if
  end do

end function testArray3DI8


!--------------------------------------------------------------------------
integer function testArray3DL1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DL1_t), intent(in) :: a_t
  testArray3DL1 = 0

  if (.not. associated(a_t%data)) then
    testArray3DL1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DL1: count =", sz(3), " size =", size(a_t%data)
    testArray3DL1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DL1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DL1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DL1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DL1 = 5
      return
    end if
  end do

end function testArray3DL1


!--------------------------------------------------------------------------
integer function testArray3DL2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DL2_t), intent(in) :: a_t
  testArray3DL2 = 0

  if (.not. associated(a_t%data)) then
    testArray3DL2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DL2: count =", sz(3), " size =", size(a_t%data)
    testArray3DL2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DL2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DL2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DL2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DL2 = 5
      return
    end if
  end do

end function testArray3DL2


!--------------------------------------------------------------------------
integer function testArray3DL(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DL_t), intent(in) :: a_t
  testArray3DL = 0

  if (.not. associated(a_t%data)) then
    testArray3DL = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DL: count =", sz(3), " size =", size(a_t%data)
    testArray3DL = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DL: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DL = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DL: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DL = 5
      return
    end if
  end do

end function testArray3DL


!--------------------------------------------------------------------------
integer function testArray3DL4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DL4_t), intent(in) :: a_t
  testArray3DL4 = 0

  if (.not. associated(a_t%data)) then
    testArray3DL4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DL4: count =", sz(3), " size =", size(a_t%data)
    testArray3DL4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DL4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DL4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DL4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DL4 = 5
      return
    end if
  end do

end function testArray3DL4


!--------------------------------------------------------------------------
integer function testArray3DL8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DL8_t), intent(in) :: a_t
  testArray3DL8 = 0

  if (.not. associated(a_t%data)) then
    testArray3DL8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DL8: count =", sz(3), " size =", size(a_t%data)
    testArray3DL8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DL8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DL8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DL8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DL8 = 5
      return
    end if
  end do

end function testArray3DL8


!--------------------------------------------------------------------------
integer function testArray3DR(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DR_t), intent(in) :: a_t
  testArray3DR = 0

  if (.not. associated(a_t%data)) then
    testArray3DR = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DR: count =", sz(3), " size =", size(a_t%data)
    testArray3DR = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DR: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DR = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DR: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DR = 5
      return
    end if
  end do

end function testArray3DR


!--------------------------------------------------------------------------
integer function testArray3DD(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DD_t), intent(in) :: a_t
  testArray3DD = 0

  if (.not. associated(a_t%data)) then
    testArray3DD = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DD: count =", sz(3), " size =", size(a_t%data)
    testArray3DD = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DD: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DD = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DD: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DD = 5
      return
    end if
  end do

end function testArray3DD


!--------------------------------------------------------------------------
integer function testArray3DC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DC_t), intent(in) :: a_t
  testArray3DC = 0

  if (.not. associated(a_t%data)) then
    testArray3DC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DC: count =", sz(3), " size =", size(a_t%data)
    testArray3DC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DC = 5
      return
    end if
  end do

end function testArray3DC


!--------------------------------------------------------------------------
integer function testArray3DDC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(3)
  type(F90_Array3DDC_t), intent(in) :: a_t
  testArray3DDC = 0

  if (.not. associated(a_t%data)) then
    testArray3DDC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(3)) then
    print *, "ERROR testArray3DDC: count =", sz(3), " size =", size(a_t%data)
    testArray3DDC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 3
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray3DDC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray3DDC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray3DDC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray3DDC = 5
      return
    end if
  end do

end function testArray3DDC


!--------------------------------------------------------------------------
integer function testArray4DI1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DI1_t), intent(in) :: a_t
  testArray4DI1 = 0

  if (.not. associated(a_t%data)) then
    testArray4DI1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DI1: count =", sz(4), " size =", size(a_t%data)
    testArray4DI1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DI1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DI1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DI1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DI1 = 5
      return
    end if
  end do

end function testArray4DI1


!--------------------------------------------------------------------------
integer function testArray4DI2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DI2_t), intent(in) :: a_t
  testArray4DI2 = 0

  if (.not. associated(a_t%data)) then
    testArray4DI2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DI2: count =", sz(4), " size =", size(a_t%data)
    testArray4DI2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DI2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DI2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DI2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DI2 = 5
      return
    end if
  end do

end function testArray4DI2


!--------------------------------------------------------------------------
integer function testArray4DI(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DI_t), intent(in) :: a_t
  testArray4DI = 0

  if (.not. associated(a_t%data)) then
    testArray4DI = 1
    return
  end if

  if (any(a_t%data .ne. -4)) then
    print *, "ERROR testArray4DI: any(a_t%data .ne. rank)"
    testArray4DI = 2
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DI: count =", sz(4), " size =", size(a_t%data)
    testArray4DI = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DI: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DI = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DI: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DI = 5
      return
    end if
  end do

end function testArray4DI


!--------------------------------------------------------------------------
integer function testArray4DI4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DI4_t), intent(in) :: a_t
  testArray4DI4 = 0

  if (.not. associated(a_t%data)) then
    testArray4DI4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DI4: count =", sz(4), " size =", size(a_t%data)
    testArray4DI4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DI4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DI4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DI4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DI4 = 5
      return
    end if
  end do

end function testArray4DI4


!--------------------------------------------------------------------------
integer function testArray4DI8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DI8_t), intent(in) :: a_t
  testArray4DI8 = 0

  if (.not. associated(a_t%data)) then
    testArray4DI8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DI8: count =", sz(4), " size =", size(a_t%data)
    testArray4DI8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DI8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DI8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DI8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DI8 = 5
      return
    end if
  end do

end function testArray4DI8


!--------------------------------------------------------------------------
integer function testArray4DL1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DL1_t), intent(in) :: a_t
  testArray4DL1 = 0

  if (.not. associated(a_t%data)) then
    testArray4DL1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DL1: count =", sz(4), " size =", size(a_t%data)
    testArray4DL1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DL1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DL1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DL1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DL1 = 5
      return
    end if
  end do

end function testArray4DL1


!--------------------------------------------------------------------------
integer function testArray4DL2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DL2_t), intent(in) :: a_t
  testArray4DL2 = 0

  if (.not. associated(a_t%data)) then
    testArray4DL2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DL2: count =", sz(4), " size =", size(a_t%data)
    testArray4DL2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DL2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DL2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DL2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DL2 = 5
      return
    end if
  end do

end function testArray4DL2


!--------------------------------------------------------------------------
integer function testArray4DL(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DL_t), intent(in) :: a_t
  testArray4DL = 0

  if (.not. associated(a_t%data)) then
    testArray4DL = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DL: count =", sz(4), " size =", size(a_t%data)
    testArray4DL = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DL: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DL = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DL: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DL = 5
      return
    end if
  end do

end function testArray4DL


!--------------------------------------------------------------------------
integer function testArray4DL4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DL4_t), intent(in) :: a_t
  testArray4DL4 = 0

  if (.not. associated(a_t%data)) then
    testArray4DL4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DL4: count =", sz(4), " size =", size(a_t%data)
    testArray4DL4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DL4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DL4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DL4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DL4 = 5
      return
    end if
  end do

end function testArray4DL4


!--------------------------------------------------------------------------
integer function testArray4DL8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DL8_t), intent(in) :: a_t
  testArray4DL8 = 0

  if (.not. associated(a_t%data)) then
    testArray4DL8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DL8: count =", sz(4), " size =", size(a_t%data)
    testArray4DL8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DL8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DL8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DL8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DL8 = 5
      return
    end if
  end do

end function testArray4DL8


!--------------------------------------------------------------------------
integer function testArray4DR(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DR_t), intent(in) :: a_t
  testArray4DR = 0

  if (.not. associated(a_t%data)) then
    testArray4DR = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DR: count =", sz(4), " size =", size(a_t%data)
    testArray4DR = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DR: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DR = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DR: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DR = 5
      return
    end if
  end do

end function testArray4DR


!--------------------------------------------------------------------------
integer function testArray4DD(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DD_t), intent(in) :: a_t
  testArray4DD = 0

  if (.not. associated(a_t%data)) then
    testArray4DD = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DD: count =", sz(4), " size =", size(a_t%data)
    testArray4DD = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DD: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DD = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DD: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DD = 5
      return
    end if
  end do

end function testArray4DD


!--------------------------------------------------------------------------
integer function testArray4DC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DC_t), intent(in) :: a_t
  testArray4DC = 0

  if (.not. associated(a_t%data)) then
    testArray4DC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DC: count =", sz(4), " size =", size(a_t%data)
    testArray4DC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DC = 5
      return
    end if
  end do

end function testArray4DC


!--------------------------------------------------------------------------
integer function testArray4DDC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(4)
  type(F90_Array4DDC_t), intent(in) :: a_t
  testArray4DDC = 0

  if (.not. associated(a_t%data)) then
    testArray4DDC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(4)) then
    print *, "ERROR testArray4DDC: count =", sz(4), " size =", size(a_t%data)
    testArray4DDC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 4
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray4DDC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray4DDC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray4DDC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray4DDC = 5
      return
    end if
  end do

end function testArray4DDC


!--------------------------------------------------------------------------
integer function testArray5DI1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DI1_t), intent(in) :: a_t
  testArray5DI1 = 0

  if (.not. associated(a_t%data)) then
    testArray5DI1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DI1: count =", sz(5), " size =", size(a_t%data)
    testArray5DI1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DI1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DI1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DI1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DI1 = 5
      return
    end if
  end do

end function testArray5DI1


!--------------------------------------------------------------------------
integer function testArray5DI2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DI2_t), intent(in) :: a_t
  testArray5DI2 = 0

  if (.not. associated(a_t%data)) then
    testArray5DI2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DI2: count =", sz(5), " size =", size(a_t%data)
    testArray5DI2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DI2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DI2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DI2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DI2 = 5
      return
    end if
  end do

end function testArray5DI2


!--------------------------------------------------------------------------
integer function testArray5DI(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DI_t), intent(in) :: a_t
  testArray5DI = 0

  if (.not. associated(a_t%data)) then
    testArray5DI = 1
    return
  end if

  if (any(a_t%data .ne. -5)) then
    print *, "ERROR testArray5DI: any(a_t%data .ne. rank)"
    testArray5DI = 2
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DI: count =", sz(5), " size =", size(a_t%data)
    testArray5DI = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DI: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DI = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DI: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DI = 5
      return
    end if
  end do

end function testArray5DI


!--------------------------------------------------------------------------
integer function testArray5DI4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DI4_t), intent(in) :: a_t
  testArray5DI4 = 0

  if (.not. associated(a_t%data)) then
    testArray5DI4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DI4: count =", sz(5), " size =", size(a_t%data)
    testArray5DI4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DI4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DI4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DI4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DI4 = 5
      return
    end if
  end do

end function testArray5DI4


!--------------------------------------------------------------------------
integer function testArray5DI8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DI8_t), intent(in) :: a_t
  testArray5DI8 = 0

  if (.not. associated(a_t%data)) then
    testArray5DI8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DI8: count =", sz(5), " size =", size(a_t%data)
    testArray5DI8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DI8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DI8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DI8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DI8 = 5
      return
    end if
  end do

end function testArray5DI8


!--------------------------------------------------------------------------
integer function testArray5DL1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DL1_t), intent(in) :: a_t
  testArray5DL1 = 0

  if (.not. associated(a_t%data)) then
    testArray5DL1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DL1: count =", sz(5), " size =", size(a_t%data)
    testArray5DL1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DL1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DL1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DL1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DL1 = 5
      return
    end if
  end do

end function testArray5DL1


!--------------------------------------------------------------------------
integer function testArray5DL2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DL2_t), intent(in) :: a_t
  testArray5DL2 = 0

  if (.not. associated(a_t%data)) then
    testArray5DL2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DL2: count =", sz(5), " size =", size(a_t%data)
    testArray5DL2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DL2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DL2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DL2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DL2 = 5
      return
    end if
  end do

end function testArray5DL2


!--------------------------------------------------------------------------
integer function testArray5DL(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DL_t), intent(in) :: a_t
  testArray5DL = 0

  if (.not. associated(a_t%data)) then
    testArray5DL = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DL: count =", sz(5), " size =", size(a_t%data)
    testArray5DL = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DL: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DL = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DL: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DL = 5
      return
    end if
  end do

end function testArray5DL


!--------------------------------------------------------------------------
integer function testArray5DL4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DL4_t), intent(in) :: a_t
  testArray5DL4 = 0

  if (.not. associated(a_t%data)) then
    testArray5DL4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DL4: count =", sz(5), " size =", size(a_t%data)
    testArray5DL4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DL4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DL4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DL4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DL4 = 5
      return
    end if
  end do

end function testArray5DL4


!--------------------------------------------------------------------------
integer function testArray5DL8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DL8_t), intent(in) :: a_t
  testArray5DL8 = 0

  if (.not. associated(a_t%data)) then
    testArray5DL8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DL8: count =", sz(5), " size =", size(a_t%data)
    testArray5DL8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DL8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DL8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DL8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DL8 = 5
      return
    end if
  end do

end function testArray5DL8


!--------------------------------------------------------------------------
integer function testArray5DR(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DR_t), intent(in) :: a_t
  testArray5DR = 0

  if (.not. associated(a_t%data)) then
    testArray5DR = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DR: count =", sz(5), " size =", size(a_t%data)
    testArray5DR = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DR: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DR = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DR: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DR = 5
      return
    end if
  end do

end function testArray5DR


!--------------------------------------------------------------------------
integer function testArray5DD(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DD_t), intent(in) :: a_t
  testArray5DD = 0

  if (.not. associated(a_t%data)) then
    testArray5DD = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DD: count =", sz(5), " size =", size(a_t%data)
    testArray5DD = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DD: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DD = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DD: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DD = 5
      return
    end if
  end do

end function testArray5DD


!--------------------------------------------------------------------------
integer function testArray5DC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DC_t), intent(in) :: a_t
  testArray5DC = 0

  if (.not. associated(a_t%data)) then
    testArray5DC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DC: count =", sz(5), " size =", size(a_t%data)
    testArray5DC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DC = 5
      return
    end if
  end do

end function testArray5DC


!--------------------------------------------------------------------------
integer function testArray5DDC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(5)
  type(F90_Array5DDC_t), intent(in) :: a_t
  testArray5DDC = 0

  if (.not. associated(a_t%data)) then
    testArray5DDC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(5)) then
    print *, "ERROR testArray5DDC: count =", sz(5), " size =", size(a_t%data)
    testArray5DDC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 5
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray5DDC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray5DDC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray5DDC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray5DDC = 5
      return
    end if
  end do

end function testArray5DDC


!--------------------------------------------------------------------------
integer function testArray6DI1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DI1_t), intent(in) :: a_t
  testArray6DI1 = 0

  if (.not. associated(a_t%data)) then
    testArray6DI1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DI1: count =", sz(6), " size =", size(a_t%data)
    testArray6DI1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DI1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DI1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DI1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DI1 = 5
      return
    end if
  end do

end function testArray6DI1


!--------------------------------------------------------------------------
integer function testArray6DI2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DI2_t), intent(in) :: a_t
  testArray6DI2 = 0

  if (.not. associated(a_t%data)) then
    testArray6DI2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DI2: count =", sz(6), " size =", size(a_t%data)
    testArray6DI2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DI2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DI2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DI2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DI2 = 5
      return
    end if
  end do

end function testArray6DI2


!--------------------------------------------------------------------------
integer function testArray6DI(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DI_t), intent(in) :: a_t
  testArray6DI = 0

  if (.not. associated(a_t%data)) then
    testArray6DI = 1
    return
  end if

  if (any(a_t%data .ne. -6)) then
    print *, "ERROR testArray6DI: any(a_t%data .ne. rank)"
    testArray6DI = 2
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DI: count =", sz(6), " size =", size(a_t%data)
    testArray6DI = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DI: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DI = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DI: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DI = 5
      return
    end if
  end do

end function testArray6DI


!--------------------------------------------------------------------------
integer function testArray6DI4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DI4_t), intent(in) :: a_t
  testArray6DI4 = 0

  if (.not. associated(a_t%data)) then
    testArray6DI4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DI4: count =", sz(6), " size =", size(a_t%data)
    testArray6DI4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DI4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DI4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DI4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DI4 = 5
      return
    end if
  end do

end function testArray6DI4


!--------------------------------------------------------------------------
integer function testArray6DI8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DI8_t), intent(in) :: a_t
  testArray6DI8 = 0

  if (.not. associated(a_t%data)) then
    testArray6DI8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DI8: count =", sz(6), " size =", size(a_t%data)
    testArray6DI8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DI8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DI8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DI8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DI8 = 5
      return
    end if
  end do

end function testArray6DI8


!--------------------------------------------------------------------------
integer function testArray6DL1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DL1_t), intent(in) :: a_t
  testArray6DL1 = 0

  if (.not. associated(a_t%data)) then
    testArray6DL1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DL1: count =", sz(6), " size =", size(a_t%data)
    testArray6DL1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DL1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DL1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DL1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DL1 = 5
      return
    end if
  end do

end function testArray6DL1


!--------------------------------------------------------------------------
integer function testArray6DL2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DL2_t), intent(in) :: a_t
  testArray6DL2 = 0

  if (.not. associated(a_t%data)) then
    testArray6DL2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DL2: count =", sz(6), " size =", size(a_t%data)
    testArray6DL2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DL2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DL2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DL2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DL2 = 5
      return
    end if
  end do

end function testArray6DL2


!--------------------------------------------------------------------------
integer function testArray6DL(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DL_t), intent(in) :: a_t
  testArray6DL = 0

  if (.not. associated(a_t%data)) then
    testArray6DL = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DL: count =", sz(6), " size =", size(a_t%data)
    testArray6DL = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DL: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DL = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DL: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DL = 5
      return
    end if
  end do

end function testArray6DL


!--------------------------------------------------------------------------
integer function testArray6DL4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DL4_t), intent(in) :: a_t
  testArray6DL4 = 0

  if (.not. associated(a_t%data)) then
    testArray6DL4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DL4: count =", sz(6), " size =", size(a_t%data)
    testArray6DL4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DL4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DL4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DL4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DL4 = 5
      return
    end if
  end do

end function testArray6DL4


!--------------------------------------------------------------------------
integer function testArray6DL8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DL8_t), intent(in) :: a_t
  testArray6DL8 = 0

  if (.not. associated(a_t%data)) then
    testArray6DL8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DL8: count =", sz(6), " size =", size(a_t%data)
    testArray6DL8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DL8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DL8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DL8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DL8 = 5
      return
    end if
  end do

end function testArray6DL8


!--------------------------------------------------------------------------
integer function testArray6DR(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DR_t), intent(in) :: a_t
  testArray6DR = 0

  if (.not. associated(a_t%data)) then
    testArray6DR = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DR: count =", sz(6), " size =", size(a_t%data)
    testArray6DR = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DR: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DR = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DR: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DR = 5
      return
    end if
  end do

end function testArray6DR


!--------------------------------------------------------------------------
integer function testArray6DD(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DD_t), intent(in) :: a_t
  testArray6DD = 0

  if (.not. associated(a_t%data)) then
    testArray6DD = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DD: count =", sz(6), " size =", size(a_t%data)
    testArray6DD = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DD: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DD = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DD: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DD = 5
      return
    end if
  end do

end function testArray6DD


!--------------------------------------------------------------------------
integer function testArray6DC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DC_t), intent(in) :: a_t
  testArray6DC = 0

  if (.not. associated(a_t%data)) then
    testArray6DC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DC: count =", sz(6), " size =", size(a_t%data)
    testArray6DC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DC = 5
      return
    end if
  end do

end function testArray6DC


!--------------------------------------------------------------------------
integer function testArray6DDC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(6)
  type(F90_Array6DDC_t), intent(in) :: a_t
  testArray6DDC = 0

  if (.not. associated(a_t%data)) then
    testArray6DDC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(6)) then
    print *, "ERROR testArray6DDC: count =", sz(6), " size =", size(a_t%data)
    testArray6DDC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 6
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray6DDC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray6DDC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray6DDC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray6DDC = 5
      return
    end if
  end do

end function testArray6DDC


!--------------------------------------------------------------------------
integer function testArray7DI1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DI1_t), intent(in) :: a_t
  testArray7DI1 = 0

  if (.not. associated(a_t%data)) then
    testArray7DI1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DI1: count =", sz(7), " size =", size(a_t%data)
    testArray7DI1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DI1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DI1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DI1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DI1 = 5
      return
    end if
  end do

end function testArray7DI1


!--------------------------------------------------------------------------
integer function testArray7DI2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DI2_t), intent(in) :: a_t
  testArray7DI2 = 0

  if (.not. associated(a_t%data)) then
    testArray7DI2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DI2: count =", sz(7), " size =", size(a_t%data)
    testArray7DI2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DI2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DI2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DI2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DI2 = 5
      return
    end if
  end do

end function testArray7DI2


!--------------------------------------------------------------------------
integer function testArray7DI(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DI_t), intent(in) :: a_t
  testArray7DI = 0

  if (.not. associated(a_t%data)) then
    testArray7DI = 1
    return
  end if

  if (any(a_t%data .ne. -7)) then
    print *, "ERROR testArray7DI: any(a_t%data .ne. rank)"
    testArray7DI = 2
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DI: count =", sz(7), " size =", size(a_t%data)
    testArray7DI = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DI: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DI = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DI: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DI = 5
      return
    end if
  end do

end function testArray7DI


!--------------------------------------------------------------------------
integer function testArray7DI4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DI4_t), intent(in) :: a_t
  testArray7DI4 = 0

  if (.not. associated(a_t%data)) then
    testArray7DI4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DI4: count =", sz(7), " size =", size(a_t%data)
    testArray7DI4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DI4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DI4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DI4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DI4 = 5
      return
    end if
  end do

end function testArray7DI4


!--------------------------------------------------------------------------
integer function testArray7DI8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DI8_t), intent(in) :: a_t
  testArray7DI8 = 0

  if (.not. associated(a_t%data)) then
    testArray7DI8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DI8: count =", sz(7), " size =", size(a_t%data)
    testArray7DI8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DI8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DI8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DI8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DI8 = 5
      return
    end if
  end do

end function testArray7DI8


!--------------------------------------------------------------------------
integer function testArray7DL1(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DL1_t), intent(in) :: a_t
  testArray7DL1 = 0

  if (.not. associated(a_t%data)) then
    testArray7DL1 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DL1: count =", sz(7), " size =", size(a_t%data)
    testArray7DL1 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DL1: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DL1 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DL1: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DL1 = 5
      return
    end if
  end do

end function testArray7DL1


!--------------------------------------------------------------------------
integer function testArray7DL2(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DL2_t), intent(in) :: a_t
  testArray7DL2 = 0

  if (.not. associated(a_t%data)) then
    testArray7DL2 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DL2: count =", sz(7), " size =", size(a_t%data)
    testArray7DL2 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DL2: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DL2 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DL2: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DL2 = 5
      return
    end if
  end do

end function testArray7DL2


!--------------------------------------------------------------------------
integer function testArray7DL(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DL_t), intent(in) :: a_t
  testArray7DL = 0

  if (.not. associated(a_t%data)) then
    testArray7DL = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DL: count =", sz(7), " size =", size(a_t%data)
    testArray7DL = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DL: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DL = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DL: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DL = 5
      return
    end if
  end do

end function testArray7DL


!--------------------------------------------------------------------------
integer function testArray7DL4(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DL4_t), intent(in) :: a_t
  testArray7DL4 = 0

  if (.not. associated(a_t%data)) then
    testArray7DL4 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DL4: count =", sz(7), " size =", size(a_t%data)
    testArray7DL4 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DL4: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DL4 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DL4: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DL4 = 5
      return
    end if
  end do

end function testArray7DL4


!--------------------------------------------------------------------------
integer function testArray7DL8(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DL8_t), intent(in) :: a_t
  testArray7DL8 = 0

  if (.not. associated(a_t%data)) then
    testArray7DL8 = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DL8: count =", sz(7), " size =", size(a_t%data)
    testArray7DL8 = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DL8: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DL8 = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DL8: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DL8 = 5
      return
    end if
  end do

end function testArray7DL8


!--------------------------------------------------------------------------
integer function testArray7DR(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DR_t), intent(in) :: a_t
  testArray7DR = 0

  if (.not. associated(a_t%data)) then
    testArray7DR = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DR: count =", sz(7), " size =", size(a_t%data)
    testArray7DR = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DR: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DR = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DR: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DR = 5
      return
    end if
  end do

end function testArray7DR


!--------------------------------------------------------------------------
integer function testArray7DD(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DD_t), intent(in) :: a_t
  testArray7DD = 0

  if (.not. associated(a_t%data)) then
    testArray7DD = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DD: count =", sz(7), " size =", size(a_t%data)
    testArray7DD = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DD: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DD = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DD: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DD = 5
      return
    end if
  end do

end function testArray7DD


!--------------------------------------------------------------------------
integer function testArray7DC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DC_t), intent(in) :: a_t
  testArray7DC = 0

  if (.not. associated(a_t%data)) then
    testArray7DC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DC: count =", sz(7), " size =", size(a_t%data)
    testArray7DC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DC = 5
      return
    end if
  end do

end function testArray7DC


!--------------------------------------------------------------------------
integer function testArray7DDC(a_t)
  use F90_kinds
  use F90_ArrayTypes
  integer, dimension(7) :: lb = (/2, 3, 4, 5, 6, 7, 8/)
  integer, dimension(7) :: ub = (/5, 7, 9, 11, 13, 15, 17/)
  integer, dimension(7) :: shp = (/4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(7) :: sz = (/4, 20, 120, 840, 6720, 60480, 604800/)
  integer :: i, shpa(7)
  type(F90_Array7DDC_t), intent(in) :: a_t
  testArray7DDC = 0

  if (.not. associated(a_t%data)) then
    testArray7DDC = 1
    return
  end if

  if (size(a_t%data) .ne. sz(7)) then
    print *, "ERROR testArray7DDC: count =", sz(7), " size =", size(a_t%data)
    testArray7DDC = 3
    return
  end if

  shpa = shape(a_t%data)
  do i = 1, 7
    if (shpa(i) .ne. shp(i)) then
      print *, "ERROR testArray7DDC: shape(a) =", shape(a_t%data), " shp =", shp
      testArray7DDC = 4
      return
    end if
    if (lbound(a_t%data,i) .ne. lb(i) .or. ubound(a_t%data,i) .ne. ub(i)) then
      print *, "ERROR testArray7DDC: i =", i, ": lb(i) =", lbound(a_t%data,i), " ub(i) =", ubound(a_t%data,i)
      testArray7DDC = 5
      return
    end if
  end do

end function testArray7DDC

