program reshape1to7
  implicit none
  interface
    subroutine chasm_reshape(rank, a, dim, b)
      integer :: rank
      integer, target, intent(in) :: a(:)
      integer, pointer :: b(:,:,:,:,:,:,:)
      integer :: dim(:)
    end subroutine chasm_reshape
  end interface

  integer :: i,j,k,l,m,n,o, count
  integer :: a(2:129), bshape(7), blbound(7), bubound(7)
  integer, pointer :: b(:,:,:,:,:,:,:)
  logical :: debug, error

  debug = .false.
  error = .false.

  do i = 2, 129
    a(i) = i
  end do

  if (debug) then
    print '(128i5)', (a(i),i=2,129)
    print *, '.'
  end if
  
  call chasm_reshape(1, a, (/2,2,2,2,2,2,2/), b)

  bshape  = shape(b)
  blbound = lbound(b)
  bubound = ubound(b)
  
  do i = 1, 7
    if (bshape(i) .ne. 2) error = .true.
    if (blbound(i) .ne. 1) error = .true.
    if (bubound(i) .ne. 2) error = .true.
    if (.not. associated(b)) then
      error = .true.
      print *, "ERROR, b is unassociated"
    end if
  end do
  if (size(a) .ne. size(b)) error = .true.


  if (debug) then
    print *, " size   of b =", size(b)
    print *, " lbound of b =", blbound
    print *, " ubound of b =", bubound
    print *, " shape  of b =", shape(b)
    print *, '.'
    print '(16i5)', (((((((b(i,j,k,l,m,n,o),i=1,2),j=1,2),k=1,2),l=1,2),m=1,2),n=1,2),o=1,2)
    print *, '.'
  end if

  count = 2
  do o = 1, 2
    do n = 1, 2
      do m = 1, 2
        do l = 1, 2
          do k = 1, 2
            do j = 1, 2
              do i = 1, 2
                if (b(i,j,k,l,m,n,o) .ne. count) then
                  error = .true.
                end if
                count = count + 1
              end do
            end do
          end do
        end do
      end do
    end do
  end do

  b(2,2,1,2,2,1,1) = 5280
  if (a(29) .ne. 5280) error = .true.

  a(37) = 3142
  if (b(2,2,1,1,1,2,1) .ne. 3142) error = .true.

  if (debug) then
    print '(128i5)', (a(i),i=2,129)
    print *, '.'
    print '(16i5)', (((((((b(i,j,k,l,m,n,o),i=1,2),j=1,2),k=1,2),l=1,2),m=1,2),n=1,2),o=1,2)
  end if

  if (error) then
    print *, "FAILED to reshape array correctly"
  end if

end program reshape1to7
