program reshape2to2
  implicit none
  interface
    subroutine chasm_reshape(rank, a, dim, b)
      integer :: rank
      integer, target, intent(in) :: a(:,:)
      integer, pointer :: b(:,:)
      integer :: dim(:)
    end subroutine chasm_reshape
  end interface

  integer, dimension(5,4) :: a = RESHAPE((/11,12,13,14,15,21,22,23,24,25,&
                                    31,32,33,34,35,41,42,43,44,45/), (/5, 4/))
  integer, pointer :: b(:,:)
  integer :: bshape(2), blbound(2), bubound(2)
  integer :: i,j, count
  logical :: debug, error

  debug = .false.
  error = .false.

  if (debug) then
    print '(5i5)', ((a(i,j),i=1,5),j=1,4)
    print *, '.'
  end if
  
  call chasm_reshape(2, a, (/10, 2/), b)

  bshape  = shape(b)
  blbound = lbound(b)
  bubound = ubound(b)
  
  if (bshape(1) .ne. 10) error = .true.
  if (bshape(2) .ne.  2) error = .true.
  if (bubound(1) .ne. 10) error = .true.
  if (bubound(2) .ne.  2) error = .true.

  do i = 1, 2
    if (blbound(i) .ne. 1) error = .true.
    if (.not. associated(b)) then
      error = .true.
      print *, "ERROR, b is unassociated"
    end if
  end do
  if (size(a) .ne. size(b)) error = .true.

  if (debug) then
    print *, " size   of b =", size(b)
    print *, " lbound of b =", blbound
    print *, " ubound of b =", bubound
    print *, " shape  of b =", shape(b)
    print *, '.'
    print '(10i5)', ((b(i,j),i=1,10),j=1,2)
    print *, '.'
  end if

  count = 11
  do j = 1, 2
    do i = 1, 10
      if (i .eq. 6) count = count + 5
      if (b(i,j) .ne. count) then
        if (debug) print *, "ERROR", i, j, b(i,j)
        error = .true.
      end if
      count = count + 1
    end do
    count = count + 5
  end do

  b(9,2) = 5280
  if (a(4,4) .ne. 5280) error = .true.

  a(3,3) = 3142
  if (b(3,2) .ne. 3142) error = .true.

  if (debug) then
    print *, b(3,2)
    print *, a(4,4)
    print *, '.'
    print '(5i5)', ((a(i,j),i=1,5),j=1,4)
    print *, '.'
    print '(10i5)', ((b(i,j),i=1,10),j=1,2)
  end if

  if (error) then
    print *, "FAILED to reshape array correctly"
  end if

end program reshape2to2
