module TestArrayTypes
  use F90_kinds

  type F90_Array1DS_t
    integer(kind=IKIND_SHORT), pointer :: data(:)
  end type F90_Array1DS_t

  type F90_Array1DI_t
    integer(kind=IKIND_INT), pointer :: data(:)
  end type F90_Array1DI_t

  type F90_Array1DL_t
    integer(kind=IKIND_LONG), pointer :: data(:)
  end type F90_Array1DL_t
end module TestArrayTypes


function test_short(a)
  use F90_kinds
  implicit none
  integer(kind=IKIND_SHORT) :: a(:)
  integer :: i, test_short

  test_short = 0
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_short = 1
    end if
  end do
end function test_short

function test_short_p(a)
  use F90_kinds
  implicit none
  integer(kind=IKIND_SHORT), pointer :: a(:)
  integer :: i, test_short_p

  test_short_p = 0
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_short_p = 1
    end if
  end do
end function test_short_p

function test_short_dp(at)
  use TestArrayTypes
  implicit none
  type(F90_Array1DS_t) :: at
  integer(kind=IKIND_SHORT), pointer :: a(:)
  integer :: i, test_short_dp

  test_short_dp = 0
  a => at%data
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_short_dp = 1
    end if
  end do
end function test_short_dp


function test_int(a)
  use F90_kinds
  implicit none
  integer(kind=IKIND_INT) :: a(:)
  integer :: i, test_int

  test_int = 0
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_int = 1
    end if
  end do
end function test_int

function test_int_p(a)
  use F90_kinds
  implicit none
  integer(kind=IKIND_INT), pointer :: a(:)
  integer :: i, test_int_p

  test_int_p = 0
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_int_p = 1
    end if
  end do
end function test_int_p

function test_int_dp(at)
  use TestArrayTypes
  implicit none
  type(F90_Array1DI_t) :: at
  integer(kind=IKIND_INT), pointer :: a(:)
  integer :: i, test_int_dp

  test_int_dp = 0
  a => at%data
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_int_dp = 1
    end if
  end do
end function test_int_dp


function test_long(a)
  use F90_kinds
  implicit none
  integer(kind=IKIND_LONG) :: a(:)
  integer :: i, test_long

  test_long = 0
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_long = 1
    end if
  end do
end function test_long

function test_long_p(a)
  use F90_kinds
  implicit none
  integer(kind=IKIND_LONG), pointer :: a(:)
  integer :: i, test_long_p

  test_long_p = 0
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_long_p = 1
    end if
  end do
end function test_long_p

function test_long_dp(at)
  use TestArrayTypes
  implicit none
  type(F90_Array1DL_t) :: at
  integer(kind=IKIND_LONG), pointer :: a(:)
  integer :: i, test_long_dp

  test_long_dp = 0
  a => at%data
  do i = 1, 10
    if (a(i) .ne. i) then
       print *, "a(", i, ") != i == ", a(i)
       test_long_dp = 1
    end if
  end do
end function test_long_dp

